<?xml version='1.0' standalone='no'?>
<!DOCTYPE xsl:stylesheet [ <!ENTITY nbsp '&#160;'> ]>
<xsl:stylesheet
 version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:gjs="http://www.georgejames.com">

  <xsl:include href='gjsForm.xsl'/>


  <xsl:template match="Form">
    <xsl:apply-templates select="auditCategories"/>
  </xsl:template>


  <xsl:template match="auditCategories">

  <gjs:form
   title='Audit Trail Settings'
   jsFile='vcset79.js'
   onload='TabStrip.fnSelect(document.getElementById("tabObjects")); frmMain.objectCreation.focus();'
   save='{/Form/@save}'
   close='{/Form/@close}'
   delete='no'
   print='{/Form/@print}'
   help='{/Form/@help}'
   ok='{/Form/@ok}'
   cancel='{/Form/@cancel}'>

    <gjs:information>
      Each audit trail message is associated with a category that defines its behavior.  The categories for messages
      relating to transfer events are defined in the transfer routes table.  The categories for change request events are 
      defined in the change request types table. The categories for all other types of audit trail message are defined in this form.
    </gjs:information>

    <!-- Leave some space after the lengthy info and before the tabs -->
    <table><tr><td height='6px'></td></tr></table>

    <gjs:tabStrip>
      <gjs:tabStripTab
       width='80'
       id='tabObjects'
       accesskey='B'
       divId='divObjects'>
        O<u>b</u>jects
      </gjs:tabStripTab>
      <gjs:tabStripTab
       width='80'
       id='tabComponents'
       accesskey='M'
       divId='divComponents'>
        Co<u>m</u>ponents
      </gjs:tabStripTab>
      <gjs:tabStripTab
       width='80'
       id='tabLocations'
       accesskey='L'
       divId='divLocations'>
        <u>L</u>ocations
      </gjs:tabStripTab>
      <gjs:tabStripTab
       width='80'
       id='tabIntegrity'
       accesskey='I'
       divId='divIntegrity'>
        <u>I</u>ntegrity
      </gjs:tabStripTab>
      <gjs:tabStripTab
       width='80'
       id='tabServices'
       accesskey='S'
       divId='divServices'>
        <u>S</u>ervices
      </gjs:tabStripTab>
      <gjs:tabStripTab
       width='80'
       id='tabOther'
       accesskey='T'
       divId='divOther'>
        O<u>t</u>her
      </gjs:tabStripTab>
    </gjs:tabStrip>

<div id='divObjects' class='tabPanelHidden' style='height: 190px;'>

  <gjs:frame>
    <!-- Set up frame column widths -->
    <gjs:columnWidths>
      <gjs:column width='240'/>
      <gjs:column width='172'/>
    </gjs:columnWidths>

    <gjs:fields>

    <xsl:call-template name='auditTrailCategoryPrompt'>
      <xsl:with-param name='attribute'>objectCreation</xsl:with-param>
      <xsl:with-param name='value' select='@objectCreation' />
      <xsl:with-param name='accesskey'>R</xsl:with-param>
      <xsl:with-param name='label'>Object c<u>r</u>eation events</xsl:with-param>
      <xsl:with-param name='hint'>The audit trail category for events that create objects.</xsl:with-param>
    </xsl:call-template>

    <xsl:call-template name='auditTrailCategoryPrompt'>
      <xsl:with-param name='attribute'>objectDeletion</xsl:with-param>
      <xsl:with-param name='value' select='@objectDeletion' />
      <xsl:with-param name='accesskey'>D</xsl:with-param>
      <xsl:with-param name='label'>Object <u>d</u>eletion events</xsl:with-param>
      <xsl:with-param name='hint'>The audit trail category for events that delete objects.</xsl:with-param>
    </xsl:call-template>
    
    <xsl:call-template name='auditTrailCategoryPrompt'>
      <xsl:with-param name='attribute'>objectRename</xsl:with-param>
      <xsl:with-param name='value' select='@objectRename' />
      <xsl:with-param name='accesskey'>E</xsl:with-param>
      <xsl:with-param name='label'>Object r<u>e</u>name events</xsl:with-param>
      <xsl:with-param name='hint'>The audit trail category that is used when objects are renamed.</xsl:with-param>
    </xsl:call-template>

    <xsl:call-template name='auditTrailCategoryPrompt'>
      <xsl:with-param name='attribute'>objectCancel</xsl:with-param>
      <xsl:with-param name='value' select='@objectCancel' />
      <xsl:with-param name='accesskey'>N</xsl:with-param>
      <xsl:with-param name='label'>Object version ca<u>n</u>cellation events</xsl:with-param>
      <xsl:with-param name='hint'>The audit trail category that is used for the cancellation of object versions.</xsl:with-param>
    </xsl:call-template>

    <xsl:call-template name='auditTrailCategoryPrompt'>
      <xsl:with-param name='attribute'>objectMerge</xsl:with-param>
        <xsl:with-param name='value' select='@objectMerge' />
      <xsl:with-param name='accesskey'>G</xsl:with-param>
      <xsl:with-param name='label'>Object version mer<u>g</u>e events</xsl:with-param>
      <xsl:with-param name='hint'>The audit trail category that is used when versions are merged.</xsl:with-param>
    </xsl:call-template>

    <xsl:call-template name='auditTrailCategoryPrompt'>
      <xsl:with-param name='attribute'>objectDisplacement</xsl:with-param>
      <xsl:with-param name='value' select='@objectDisplacement' />
      <xsl:with-param name='accesskey'>A</xsl:with-param>
      <xsl:with-param name='label'>Object version displ<u>a</u>cement events</xsl:with-param>
      <xsl:with-param name='hint'>The audit trail category that is used when one object is displaced at the destination by the transfer of another object.</xsl:with-param>
    </xsl:call-template>

    </gjs:fields>
  </gjs:frame>
</div>

<div id='divComponents' class='tabPanelHidden' style='height: 190px;'>
  <gjs:frame>
    <!-- Set up frame column widths -->
    <gjs:columnWidths>
      <gjs:column width='240'/>
      <gjs:column width='172'/>
    </gjs:columnWidths>

    <gjs:fields>

    <xsl:call-template name='auditTrailCategoryPrompt'>
      <xsl:with-param name='attribute'>componentTakeOn</xsl:with-param>
      <xsl:with-param name='value' select='@componentTakeOn' />
      <xsl:with-param name='accesskey'>K</xsl:with-param>
      <xsl:with-param name='label'>Component ta<u>k</u>e-on events</xsl:with-param>
      <xsl:with-param name='hint'>The category that is used when components are registered and loaded into a location using the bulk take-on function.</xsl:with-param>
    </xsl:call-template>

    <xsl:call-template name='auditTrailCategoryPrompt'>
      <xsl:with-param name='attribute'>componentRegistration</xsl:with-param>
      <xsl:with-param name='value' select='@componentRegistration' />
      <xsl:with-param name='accesskey'>R</xsl:with-param>
      <xsl:with-param name='label'>Component <u>r</u>egistration events</xsl:with-param>
      <xsl:with-param name='hint'>The audit trail category for events that register components.</xsl:with-param>
    </xsl:call-template>

    <xsl:call-template name='auditTrailCategoryPrompt'>
      <xsl:with-param name='attribute'>componentUnregistration</xsl:with-param>
      <xsl:with-param name='value' select='@componentUnregistration' />
      <xsl:with-param name='accesskey'>N</xsl:with-param>
      <xsl:with-param name='label'>Component u<u>n</u>registration events</xsl:with-param>
      <xsl:with-param name='hint'>The audit trail category for events that unregister components.</xsl:with-param>
    </xsl:call-template>

    <xsl:call-template name='auditTrailCategoryPrompt'>
      <xsl:with-param name='attribute'>componentDeletion</xsl:with-param>
      <xsl:with-param name='value' select='@componentDeletion' />
      <xsl:with-param name='accesskey'>D</xsl:with-param>
      <xsl:with-param name='label'>Component physical <u>d</u>eletion events</xsl:with-param>
      <xsl:with-param name='hint'>The audit trail category for events that physically delete components.</xsl:with-param>
    </xsl:call-template>

    <xsl:call-template name='auditTrailCategoryPrompt'>
      <xsl:with-param name='attribute'>componentCompileError</xsl:with-param>
      <xsl:with-param name='value' select='@componentCompileError' />
      <xsl:with-param name='accesskey'>E</xsl:with-param>
      <xsl:with-param name='label'>Component compilation <u>e</u>rror events</xsl:with-param>
      <xsl:with-param name='hint'>The category that is used when component compilation errors occurs.</xsl:with-param>
    </xsl:call-template>

    <xsl:call-template name='auditTrailCategoryPrompt'>
      <xsl:with-param name='attribute'>componentCompileSuccess</xsl:with-param>
      <xsl:with-param name='value' select='@componentCompileSuccess' />
      <xsl:with-param name='accesskey'>U</xsl:with-param>
      <xsl:with-param name='label'>Component compilation s<u>u</u>ccess events</xsl:with-param>
      <xsl:with-param name='hint'>The category that is used when component compilation succeeds.</xsl:with-param>
    </xsl:call-template>

    </gjs:fields>
  </gjs:frame>
</div>

<div id='divLocations' class='tabPanelHidden' style='height: 190px;'>
  <gjs:frame>
    <!-- Set up frame column widths -->
    <gjs:columnWidths>
      <gjs:column width='240'/>
      <gjs:column width='172'/>
    </gjs:columnWidths>

    <gjs:fields>

    <xsl:call-template name='auditTrailCategoryPrompt'>
      <xsl:with-param name='attribute'>locationCopy</xsl:with-param>
      <xsl:with-param name='value' select='@locationCopy' />
      <xsl:with-param name='accesskey'>Y</xsl:with-param>
      <xsl:with-param name='label'>Location cop<u>y</u> events</xsl:with-param>
      <xsl:with-param name='hint'>Object level events that are a result of bulk copy operations on a location are recorded using this category.</xsl:with-param>
    </xsl:call-template>

    <xsl:call-template name='auditTrailCategoryPrompt'>
      <xsl:with-param name='attribute'>locationDelete</xsl:with-param>
      <xsl:with-param name='value' select='@locationDelete' />
      <xsl:with-param name='accesskey'>E</xsl:with-param>
      <xsl:with-param name='label'>Location d<u>e</u>letion events</xsl:with-param>
      <xsl:with-param name='hint'>Object level events that are a result of bulk deletion operations on a location are recorded using this category.</xsl:with-param>
    </xsl:call-template>

    </gjs:fields>
  </gjs:frame>
</div>

<div id='divIntegrity' class='tabPanelHidden' style='height: 190px;'>
  <gjs:frame>
    <!-- Set up frame column widths -->
    <gjs:columnWidths>
      <gjs:column width='240'/>
      <gjs:column width='172'/>
    </gjs:columnWidths>

    <gjs:fields>
    <xsl:call-template name='auditTrailCategoryPrompt'>
      <xsl:with-param name='attribute'>integrityProgress</xsl:with-param>
      <xsl:with-param name='value' select='@integrityProgress' />
      <xsl:with-param name='accesskey'>R</xsl:with-param>
      <xsl:with-param name='label'>Integrity check p<u>r</u>ogress messages</xsl:with-param>
      <xsl:with-param name='hint'>The category used for integrity checking progress messages</xsl:with-param>
    </xsl:call-template>

    <xsl:call-template name='auditTrailCategoryPrompt'>
      <xsl:with-param name='attribute'>integrityError</xsl:with-param>
      <xsl:with-param name='value' select='@integrityError' />
      <xsl:with-param name='accesskey'>E</xsl:with-param>
      <xsl:with-param name='label'>Integrity check <u>e</u>rror messages</xsl:with-param>
      <xsl:with-param name='hint'>The category used for integrity checking error messages</xsl:with-param>
    </xsl:call-template>

    <xsl:call-template name='auditTrailCategoryPrompt'>
      <xsl:with-param name='attribute'>integrityCompletion</xsl:with-param>
      <xsl:with-param name='value' select='@integrityCompletion' />
      <xsl:with-param name='accesskey'>G</xsl:with-param>
      <xsl:with-param name='label'>Inte<u>g</u>rity check completion messages - clean</xsl:with-param>
      <xsl:with-param name='hint'>The category used for integrity checking completion messages when no errors were found</xsl:with-param>
    </xsl:call-template>

    <xsl:call-template name='auditTrailCategoryPrompt'>
      <xsl:with-param name='attribute'>integrityCompletionWithErrors</xsl:with-param>
      <xsl:with-param name='value' select='@integrityCompletionWithErrors' />
      <xsl:with-param name='accesskey'>Y</xsl:with-param>
      <xsl:with-param name='label'>Integrit<u>y</u> check completion messages - errors</xsl:with-param>
      <xsl:with-param name='hint'>The category used for integrity checking completion messages when at least one error was found</xsl:with-param>
    </xsl:call-template>

    </gjs:fields>
  </gjs:frame>
</div>

    <div id='divServices' class='tabPanelHidden' style='height: 190px;'>
      <gjs:frame>
        <!-- Set up frame column widths -->
        <gjs:columnWidths>
          <gjs:column width='240'/>
          <gjs:column width='172'/>
        </gjs:columnWidths>

        <gjs:fields>

        <xsl:call-template name='auditTrailCategoryPrompt'>
          <xsl:with-param name='attribute'>serviceStart</xsl:with-param>
          <xsl:with-param name='value' select='@serviceStart' />
          <xsl:with-param name='accesskey'>A</xsl:with-param>
          <xsl:with-param name='label'>Service st<u>a</u>rt messages</xsl:with-param>
          <xsl:with-param name='hint'>The category used for start messages for services, such as the install daemon, beyond compare FTP server, etc.</xsl:with-param>
        </xsl:call-template>

        <xsl:call-template name='auditTrailCategoryPrompt'>
          <xsl:with-param name='attribute'>serviceStop</xsl:with-param>
          <xsl:with-param name='value' select='@serviceStop' />
          <xsl:with-param name='accesskey'>V</xsl:with-param>
          <xsl:with-param name='label'>Ser<u>v</u>ice stop messages</xsl:with-param>
          <xsl:with-param name='hint'>The category used for stop messages for services, such as the install daemon, beyond compare FTP server, etc.</xsl:with-param>
        </xsl:call-template>

        <xsl:call-template name='auditTrailCategoryPrompt'>
          <xsl:with-param name='attribute'>servicePause</xsl:with-param>
          <xsl:with-param name='value' select='@servicePause' />
          <xsl:with-param name='accesskey'>U</xsl:with-param>
          <xsl:with-param name='label'>Service pa<u>u</u>se messages</xsl:with-param>
          <xsl:with-param name='hint'>The category used for pause messages for services, such as the install daemon, beyond compare FTP server, etc.</xsl:with-param>
        </xsl:call-template>

        <xsl:call-template name='auditTrailCategoryPrompt'>
          <xsl:with-param name='attribute'>serviceResume</xsl:with-param>
          <xsl:with-param name='value' select='@serviceResume' />
          <xsl:with-param name='accesskey'>R</xsl:with-param>
          <xsl:with-param name='label'>Service <u>r</u>esume messages</xsl:with-param>
          <xsl:with-param name='hint'>The category used for resume messages for services, such as the install daemon, beyond compare FTP server, etc.</xsl:with-param>
        </xsl:call-template>

        </gjs:fields>
      </gjs:frame>
    </div>

    <div id='divOther' class='tabPanelHidden' style='height: 190px;'>
      <gjs:frame>
        <!-- Set up frame column widths -->
        <gjs:columnWidths>
          <gjs:column width='240'/>
          <gjs:column width='172'/>
        </gjs:columnWidths>

        <gjs:fields>

        <xsl:call-template name='auditTrailCategoryPrompt'>
          <xsl:with-param name='attribute'>transactionSummary</xsl:with-param>
          <xsl:with-param name='value' select='@transactionSummary' />
          <xsl:with-param name='accesskey'>R</xsl:with-param>
          <xsl:with-param name='label'>T<u>r</u>ansaction summary messages</xsl:with-param>
          <xsl:with-param name='hint'>The category used for messages that summarize transfer transactions.</xsl:with-param>
        </xsl:call-template>

        <xsl:call-template name='auditTrailCategoryPrompt'>
          <xsl:with-param name='attribute'>transactionSummaryError</xsl:with-param>
          <xsl:with-param name='value' select='@transactionSummaryError' />
          <xsl:with-param name='accesskey'>E</xsl:with-param>
          <xsl:with-param name='label'>Transaction summary (<u>e</u>rrors)</xsl:with-param>
          <xsl:with-param name='hint'>The category used for messages that summarize transfer transactions in which at least one error occurred.</xsl:with-param>
        </xsl:call-template>

        <xsl:call-template name='auditTrailCategoryPrompt'>
          <xsl:with-param name='attribute'>transactionSummaryBackground</xsl:with-param>
          <xsl:with-param name='value' select='@transactionSummaryBackground' />
          <xsl:with-param name='accesskey'>B</xsl:with-param>
          <xsl:with-param name='label'><u>B</u>ackground transaction summary messages</xsl:with-param>
          <xsl:with-param name='hint'>The category used for messages that summarize background transfer transactions.</xsl:with-param>
        </xsl:call-template>

        <xsl:call-template name='auditTrailCategoryPrompt'>
          <xsl:with-param name='attribute'>transactionSummaryErrorBackground</xsl:with-param>
          <xsl:with-param name='value' select='@transactionSummaryErrorBackground' />
          <xsl:with-param name='accesskey'>A</xsl:with-param>
          <xsl:with-param name='label'>B<u>a</u>ckground transaction summary (<u>e</u>rrors)</xsl:with-param>
          <xsl:with-param name='hint'>The category used for messages that summarize background transfer transactions in which at least one error occurred.</xsl:with-param>
        </xsl:call-template>

        <gjs:inputHidden id='revision' name='revision' value='{@revision}'/>

        </gjs:fields>
      </gjs:frame>
    </div>

    <!-- Leave some space after the panels and before the buttons -->
    <table><tr><td height='6px'></td></tr></table>

  </gjs:form>
</xsl:template>


<!-- Standard prompt for audit trail category -->
<xsl:template name='auditTrailCategoryPrompt'>
  <xsl:param name='attribute'/>
  <xsl:param name='value'/>
  <xsl:param name='accesskey'/>
  <xsl:param name='label'/>
  <xsl:param name='hint'/>
  
  <gjs:list1
   id='{$attribute}'
   accesskey='{$accesskey}'
   width='172'
   value='{$value}'
   onchange='Form.fnChanged()'
   readonly='0'>
    <label><xsl:copy-of select='$label'/></label>
    <hint><xsl:copy-of select='$hint'/></hint>
  <item>
    <label></label>
    <value></value>
  </item>
    <xsl:apply-templates select='/Form/categories/category' mode='list1'>
      <xsl:sort select='@name'/>         
    </xsl:apply-templates>
  </gjs:list1>

</xsl:template>


<!-- category list boxes -->
<xsl:template match='category' mode="list1">
  <item>
    <label><xsl:value-of select="@name" /></label>
    <value><xsl:value-of select="@category" /></value>
  </item>
</xsl:template>

</xsl:stylesheet>
