<?xml version='1.0' encoding='UTF-8'?>
<!DOCTYPE xsl:stylesheet [ <!ENTITY nbsp '&#160;'> ]>
<xsl:stylesheet 
 version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:gjs="http://www.georgejames.com">


  <!-- Audit Trail Row
       ===============
  -->


  <xsl:include href='gjsControlsTemplates.xsl' />


  <!-- Public - Column heading content -->
  <xsl:template name='divMainHeadContent'>
    <xsl:param name='divMainHeadId' select='"divMainHead"'/>

    	<table class='layoutTable' width='1000px' gjsTreeId='AuditTrail_List'>
    	  <tr>

          <xsl:call-template name='gjs:treeMoresMainHeading' />

          <td width='25'></td>

          <xsl:call-template name='gjs:treeColumnHeading'>
            <xsl:with-param name='width' select='"130"'/>
	          <xsl:with-param name='columnId'>DateTime</xsl:with-param>
            <xsl:with-param name='caption'>Date/Time</xsl:with-param>         
            <xsl:with-param name='selected'>descending</xsl:with-param>
            <xsl:with-param name='divMainHeadId'><xsl:value-of select='$divMainHeadId'/></xsl:with-param>
						<xsl:with-param name='previousColumnResizable' select='0' />
          </xsl:call-template>

          <xsl:call-template name='gjs:treeColumnHeading'>
            <xsl:with-param name='width' select='"150"'/> 
	          <xsl:with-param name='columnId'>Item</xsl:with-param>
            <xsl:with-param name='caption'>Item</xsl:with-param>         
            <xsl:with-param name='divMainHeadId'><xsl:value-of select='$divMainHeadId'/></xsl:with-param>
          </xsl:call-template>

          <xsl:call-template name='gjs:treeColumnHeading'>
            <xsl:with-param name='width' select='"21"'/>
	          <xsl:with-param name='columnId'>Flag</xsl:with-param>
            <xsl:with-param name='caption'>
								<img src='vcmFlagGrey.gif' height='14px' style='vertical-align: middle'/>
						</xsl:with-param>         
            <xsl:with-param name='divMainHeadId'><xsl:value-of select='$divMainHeadId'/></xsl:with-param>
          </xsl:call-template>

          <xsl:call-template name='gjs:treeColumnHeading'>
            <xsl:with-param name='width' select='"450"'/>
	          <xsl:with-param name='columnId'>Message</xsl:with-param>
            <xsl:with-param name='caption'>Message</xsl:with-param>         
            <xsl:with-param name='divMainHeadId'><xsl:value-of select='$divMainHeadId'/></xsl:with-param>
          </xsl:call-template>

          <xsl:call-template name='gjs:treeColumnHeading'>
            <xsl:with-param name='width' select='"80"'/> 
           <xsl:with-param name='columnId'>Category</xsl:with-param>
           <xsl:with-param name='caption'>Category</xsl:with-param>         
            <xsl:with-param name='divMainHeadId'><xsl:value-of select='$divMainHeadId'/></xsl:with-param>
          </xsl:call-template>

          <xsl:call-template name='gjs:treeColumnHeading'>
            <xsl:with-param name='width' select='"100"'/> 
	          <xsl:with-param name='columnId'>UserId</xsl:with-param>
            <xsl:with-param name='caption'>User ID</xsl:with-param>         
            <xsl:with-param name='divMainHeadId'><xsl:value-of select='$divMainHeadId'/></xsl:with-param>
          </xsl:call-template>

          <xsl:call-template name='gjs:treeColumnHeading'>
            <xsl:with-param name='width' select='"100"'/> 
	          <xsl:with-param name='columnId'>ActionBy</xsl:with-param>
            <xsl:with-param name='caption'>Action By</xsl:with-param>         
            <xsl:with-param name='divMainHeadId'><xsl:value-of select='$divMainHeadId'/></xsl:with-param>
          </xsl:call-template>

          <xsl:call-template name='gjs:treeColumnHeading'>
            <xsl:with-param name='width' select='"100"'/> 
	          <xsl:with-param name='columnId'>Transaction</xsl:with-param>
            <xsl:with-param name='caption'>Transaction</xsl:with-param>         
            <xsl:with-param name='divMainHeadId'><xsl:value-of select='$divMainHeadId'/></xsl:with-param>
          </xsl:call-template>

          <td width='*'></td>
        </tr>
      </table>

  </xsl:template>
  
  <xsl:template name='folderContent'>
		<xsl:param name='rowId'/>
      <!-- same as leafContent -->
      <xsl:call-template name='leafContent'>
        <xsl:with-param name='rowId' select='$rowId'/>
      </xsl:call-template> 
  </xsl:template>

  <!-- Sub-folder method -->
  <xsl:template name='subFolderMethod'>
    <xsl:text>AuditTrail.fnItem</xsl:text>
  </xsl:template>

  <!-- Sub-folder arguments -->
  <xsl:template name='subFolderArguments'>
    <xsl:param name='rowId'/>
    
  	<xsl:variable name='element'>
  		fnElement("<xsl:value-of select='$rowId'/>itemCell")
  	</xsl:variable>
  
    <xsl:choose>
      <xsl:when test='audit/@changeRequest and (audit/@changeRequest!="")'>
        <xsl:text>"</xsl:text><xsl:value-of select='$rowId'/><xsl:text>main"</xsl:text>
        <xsl:text>+delimiter+"@"+getAttr(</xsl:text><xsl:value-of select='$element'/><xsl:text>,"gjsItem")</xsl:text>
        <xsl:text>+delimiter+"</xsl:text><xsl:value-of select='audit/@atline'/><xsl:text>"</xsl:text>
        <xsl:text>+delimiter+gjsTree.fnMores(gCurrentCell)</xsl:text>
      </xsl:when>
      <xsl:otherwise>
        <xsl:text>"</xsl:text><xsl:value-of select='$rowId'/><xsl:text>main"</xsl:text>
        <xsl:text>+delimiter+getAttr(</xsl:text><xsl:value-of select='$element'/><xsl:text>,"gjsItem")</xsl:text>
        <xsl:text>+delimiter+"</xsl:text><xsl:value-of select='audit/@atline'/><xsl:text>"</xsl:text>
        <xsl:text>+delimiter+gjsTree.fnMores(gCurrentCell)</xsl:text>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:if test='@onlyFoot'>
        <xsl:text>+delimiter+"</xsl:text><xsl:value-of select='@onlyFoot'/><xsl:text>"</xsl:text>
    </xsl:if>  
  </xsl:template>

  <xsl:template name='leafContent'>
		<xsl:param name='rowId'/>
    
    <!-- Get icon - use audit trail's category if present, otherwise use message's  -->
    <xsl:variable name='icon'>
      <xsl:choose>
        <xsl:when test='audit'>
          <xsl:value-of select='audit/category/@icon' />
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select='category/@icon' />          
        </xsl:otherwise>
      </xsl:choose>        
    </xsl:variable>

    <!-- Get category - use audit trail's if present, otherwise use message's  -->
    <xsl:variable name='categoryName'>
      <xsl:choose>
        <xsl:when test='audit'>
          <xsl:value-of select='audit/category/@name' />
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select='category/@name' />          
        </xsl:otherwise>
      </xsl:choose>        
    </xsl:variable>


    <!-- Get the message text - use audit trail's if present, otherwise use message text -->
    <xsl:variable name='message'>
      <xsl:choose>
        <xsl:when test='audit'>
          <xsl:value-of select='audit/@message' />
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select='message/@message' />          
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <!-- Get dateTime - use audit trail's date/time if present, otherwise message date/time -->
    <xsl:variable name='dateTime'>
      <xsl:choose>
        <xsl:when test='audit'>
          <xsl:value-of select='audit/@dateTime' />
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select='message/@dateTime' />          
        </xsl:otherwise>
      </xsl:choose>        
    </xsl:variable>

    <!-- transform dateTime to external format -->
    <xsl:variable name='formattedDateTime'>
      <xsl:call-template name='gjs:formatDateTime'>
        <xsl:with-param name='locale' select='/ServerLink/user/@locale'/>
        <xsl:with-param name='date' select='$dateTime'/>
      </xsl:call-template>
    </xsl:variable>


    <!-- Icon for record -->
    <td class='noHighlight' width='25px'>

      <img
       src='{$icon}'
       width='25px'
       height='16px'>
      </img>
    </td>

    <!-- Sort the date/time column by atline as this is actually in date/time order 
         whereas two audit events occuring within the same instant could be sorted in either order -->
    <td class='treeCell' gjsSort='{audit/@atline}'>
      <div nowrap='nowrap'>
        <xsl:value-of select='$formattedDateTime' />
      </div>
    </td>

		<!-- Item cell, may be an ObjectVersion, ChangeRequest or an ad-hoc message -->
    <td
     class='treeCell'>
			<xsl:choose>
				<!-- ObjectVersion -->
				<xsl:when test='audit/@objectVersion and (audit/@objectVersion!="")'>
					<xsl:choose>
						<xsl:when test='/ServerLink/allowedMethods/method[@name="Object.fnOpen"]'>
							<span
							 id='{$rowId}itemCell'
							 nowrap='nowrap'
							 tabindex='-1'
							 onclick='fnItemSelect(this);fnEventStop()'
							 onfocus='fnItemSelect(this);Class.fnSelect(Object,this);'
							 oncontextmenu='fnContextMenu("popObject")'
							 ondblclick='Object.fnOpen(getAttr(this,"gjsItem"));fnEventStop();'
							 gjsItem='{audit/@objectVersion}'>
							  <xsl:value-of select='audit/@objectVersion' />
							</span>
						</xsl:when>
							<xsl:otherwise>
								<span nowrap='nowrap'>
								  <xsl:value-of select='audit/@objectVersion' />
								</span>							
							</xsl:otherwise>
					</xsl:choose>
				</xsl:when>
				<!-- ChangeRequest -->
				<xsl:when test='audit/@changeRequest and (audit/@changeRequest!="")'>
					<xsl:choose>
						<xsl:when test='/ServerLink/allowedMethods/method[@name="ChangeRequest.fnOpen"]'>
							<span
							 id='{$rowId}itemCell'
							 nowrap='nowrap'
							 tabindex='-1'
							 onclick='fnItemSelect(this);fnEventStop()'
							 onfocus='fnItemSelect(this);Class.fnSelect(ChangeRequest,this);'
							 oncontextmenu='fnContextMenu("popChangeRequest")'
							 ondblclick='ChangeRequest.fnOpen(getAttr(this,"gjsItem"));fnEventStop();'
							 gjsItem='{audit/@changeRequest}'
							 gjsParentId=''>
							  <xsl:value-of select='audit/@changeRequest' />
							</span>
						</xsl:when>
							<xsl:otherwise>
								<span nowrap='nowrap'>
								  <xsl:value-of select='audit/@changeRequest' />
								</span>
							</xsl:otherwise>
					</xsl:choose>
				</xsl:when>
				<!-- Ad-hoc message -->
				<xsl:otherwise>
					<span nowrap='nowrap'>
					  <xsl:value-of select='message/@item' />
					</span>			
				</xsl:otherwise>		
			</xsl:choose>
    </td>

    <td class='treeCell'>          
      <div nowrap='nowrap'>
      <xsl:choose>
        <xsl:when test='audit/parameters/@features &lt; 7'>
          <xsl:attribute name='gjsSort'>0</xsl:attribute>
          <img
           src='vcm_blank.gif'
           title='Message flagging is not available on this edition of Deltanji'
          />
        </xsl:when>
				<!-- For action by this user - red flag -->
        <xsl:when test='audit/@actioned="no" and /ServerLink/user/@user=audit/@actionBy'>
          <xsl:attribute name='gjsSort'>2</xsl:attribute>
          <img
           src='vcmFlag.gif'
           title='For action by {audit/@actionBy}'
           onmouseover='this.src=getAttr(this,"gjsOtherImage")'
           onmouseout='this.src=getAttr(this,"gjsCurrentImage")'
           gjsCurrentImage='vcmFlag.gif'
           gjsOtherImage='vcmFlag.gif'
           gjsItem='{audit/@item}'
           gjsAtLine='{audit/@atline}'
           gjsRevision='{audit/@revision}'
           gjsActionBy='{audit/@actionBy}'
           onclick='AuditTrail.fnActionToggleThis(this)'/>
        </xsl:when>
        <!-- For action by some other user - grey flag - no behaviour -->
        <xsl:when test='audit/@actioned="no"'>
          <xsl:attribute name='gjsSort'>1</xsl:attribute>
          <img
           src='vcmFlagGrey.gif'
           title='For action by {audit/@actionBy}'
           gjsItem='{audit/@item}'
           gjsAtLine='{audit/@atline}'
           gjsRevision='{audit/@revision}'
           gjsActionBy='{audit/@actionBy}'/>
        </xsl:when>
				<!-- Not for action by anyone -->
        <xsl:otherwise>
          <xsl:attribute name='gjsSort'>0</xsl:attribute>
          <img
           src='vcm_blank.gif'
           onmouseover='this.src=getAttr(this,"gjsOtherImage")'
           onmouseout='this.src=getAttr(this,"gjsCurrentImage")'
           gjsCurrentImage='vcm_blank.gif'
           gjsOtherImage='vcmFlagGrey.gif'
           gjsItem='{audit/@item}'
           gjsAtLine='{audit/@atline}'
           gjsRevision='{audit/@revision}'
           gjsActionBy='{audit/@actionBy}'
           onclick='AuditTrail.fnActionToggleThis(this)'/>
        </xsl:otherwise>
      </xsl:choose>
      </div>
    </td>

    <td class='treeCell'>
      <div nowrap='nowrap'>
        <xsl:value-of select='$message'/>    
      </div>
    </td>

    <td class='treeCell'>
      <div nowrap='nowrap'>
        <xsl:value-of select='$categoryName'/>    
      </div>
    </td>

    <td class='treeCell'>
      <div nowrap='nowrap'>
        <xsl:value-of select='audit/@user'/>
      </div>
    </td>

    <td class='treeCell'>
      <div nowrap='nowrap'>
        <xsl:value-of select='audit/@actionBy'/>
      </div>
    </td>

    <td class='treeCell'>
      <div nowrap='nowrap'>
        <xsl:value-of select='audit/@transaction'/>
      </div>
    </td>

  </xsl:template>


</xsl:stylesheet>
