<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<!-- This stylesheet transforms an xml formatted document into its corresponding global node representation -->
<!-- Physical Locations -->
<xsl:strip-space elements="route"/>

<!-- Global node and data -->
<xsl:template match="physicalLocation">
^%vclp("<xsl:value-of select='@physicalLocation'/>")
<xsl:value-of select='@description'/>\<xsl:value-of select='@storageFormat'/>\<xsl:call-template name='multiVersion'/>\<xsl:call-template name='remLocation'/>\<xsl:call-template name='locationType'/>\<xsl:call-template name='dependencyCheck'/>\<xsl:value-of select='@revision'/>
^%vclp("<xsl:value-of select='@physicalLocation'/>",0)
<xsl:value-of select='@physicalAddress'/>
</xsl:template>

<xsl:template name="multiVersion">
  <xsl:variable name="value" select="./@multiVersion" />
  <xsl:choose>
    <xsl:when test="$value='Yes'">1</xsl:when>
    <xsl:when test="$value='No'">0</xsl:when>
    <xsl:otherwise>0</xsl:otherwise>
  </xsl:choose>
</xsl:template>

<xsl:template name="remLocation">
  <xsl:variable name="value" select="./@remLocation" />
  <xsl:choose>
    <xsl:when test="$value='Yes'">1</xsl:when>
    <xsl:when test="$value='No'">0</xsl:when>
    <xsl:otherwise>0</xsl:otherwise>
  </xsl:choose>
</xsl:template>

<xsl:template name="locationType">
  <xsl:variable name="value" select="./@locationType" />
  <xsl:choose>
    <xsl:when test="$value='Controlled'">C</xsl:when>
    <xsl:when test="$value='Uncontrolled'">U</xsl:when>
    <xsl:otherwise>C</xsl:otherwise>
  </xsl:choose>
</xsl:template>

<xsl:template name="dependencyCheck">
  <xsl:variable name="value" select="./@dependencyCheck" />
  <xsl:choose>
    <xsl:when test="$value='Internal'">d</xsl:when>
    <xsl:when test="$value='Compare'">p</xsl:when>
    <xsl:when test="$value='Timestamp'">pd</xsl:when>
    <xsl:otherwise>d</xsl:otherwise>
  </xsl:choose>
</xsl:template>




</xsl:stylesheet>
