<?xml version='1.0' standalone='no'?>
<!DOCTYPE xsl:stylesheet [ <!ENTITY nbsp '&#160;'> ]>
<xsl:stylesheet
 version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:gjs="http://www.georgejames.com">

<xsl:include href='gjsForm.xsl'/>

<xsl:template match="Form">
  <xsl:apply-templates select="customMenus"/>
</xsl:template>

<xsl:template match="customMenus">

<gjs:form
 title='Custom Menus'
 jsFile='vcset71.js'
 onload='frmMain.mainMenu.focus();'
 save='{/Form/@save}'
 close='{/Form/@close}'
 delete='no'
 print='{/Form/@print}'
 help='{/Form/@help}'
 ok='{/Form/@ok}'
 cancel='{/Form/@cancel}'>

  <gjs:information>
    Custom menus for the terminal interface.
  </gjs:information>

<div id='divCustomMenus' class='visible' style='height: 200'>
  <gjs:frame>
  <!-- Set up frame column widths -->
  <gjs:columnWidths>
    <gjs:column width='220'/>
    <gjs:column width='220'/>
  </gjs:columnWidths>

  <gjs:fields>

    <gjs:list1
     id='mainMenu'
     accesskey='M'
     width='220'
     value='{@mainMenu}'
     onchange='Form.fnChanged()'
     readonly='0'>
      <item>
       <label></label>
       <value></value>
      </item>
      <label><u>M</u>ain menu (invoked by D ^%VC)</label>
      <hint>Select appropriate menu</hint>
      <xsl:apply-templates select="/Form/menus/menu" mode='list1' />
    </gjs:list1>

    <tr><td height='10'></td></tr>

    <gjs:list1
     id='vcp'
     accesskey='R'
     width='220'
     value='{@vcp}'
     onchange='Form.fnChanged()'
     readonly='0'>
      <item>
       <label></label>
       <value></value>
      </item>
      <label>P<u>r</u>ogrammer menu (invoked by D ^%VCP)</label>
      <hint>Select appropriate menu</hint>
      <xsl:apply-templates select="/Form/menus/menu" mode='list1' />
    </gjs:list1>

    <tr><td height='10'></td></tr>

    <gjs:list1
     id='vcm'
     accesskey='N'
     width='220'
     value='{@vcm}'
     onchange='Form.fnChanged()'
     readonly='0'>
      <item>
       <label></label>
       <value></value>
      </item>
      <label>Ma<u>n</u>ager menu (invoked by D ^%VCM)</label>
      <hint>Select appropriate menu</hint>
      <xsl:apply-templates select="/Form/menus/menu" mode='list1' />
    </gjs:list1>

    <tr><td height='10'></td></tr>
    
    <gjs:list1
     id='vco'
     accesskey='T'
     width='220'
     value='{@vco}'
     onchange='Form.fnChanged()'
     readonly='0'>
      <item>
       <label></label>
       <value></value>
      </item>
      <label>Opera<u>t</u>or menu (invoked by D ^%VCO)</label>
      <hint>Select appropriate menu</hint>
      <xsl:apply-templates select="/Form/menus/menu" mode='list1' />
    </gjs:list1>

    <tr><td height='10'></td></tr>

    <gjs:list1
     id='vcl'
     accesskey='L'
     width='220'
     value='{@vcl}'
     onchange='Form.fnChanged()'
     readonly='0'>
      <item>
       <label></label>
       <value></value>
      </item>
      <label><u>L</u>ive menu (invoked by D ^%VCL)</label>
      <hint>Select appropriate menu</hint>
      <xsl:apply-templates select="/Form/menus/menu" mode='list1' />
    </gjs:list1>

    <tr><td height='10'></td></tr>

    <gjs:list1
     id='setup'
     accesskey='E'
     width='220'
     value='{@setup}'
     onchange='Form.fnChanged()'
     readonly='0'>
      <label>S<u>e</u>tup menu (invoked by D ^%VCSETUP)</label>
      <hint>Select appropriate menu</hint>
      <item>
       <label></label>
       <value></value>
      </item>
      <xsl:apply-templates select="/Form/menus/menu" mode='list1' />
    </gjs:list1>


  </gjs:fields>

  <gjs:inputHidden id='revision' value='{@revision}'/>

  </gjs:frame>
</div>
</gjs:form>
</xsl:template>


<!-- Device Type list box -->
<xsl:template match='menu' mode="list1">
<item>
  <label><xsl:value-of select="@menu" /></label>
  <value><xsl:value-of select="@menu" /></value>
</item>
</xsl:template>


</xsl:stylesheet>
