<?xml version='1.0' standalone='no'?>
<!DOCTYPE xsl:stylesheet [ <!ENTITY nbsp '&#160;'> ]>
<xsl:stylesheet
 version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:gjs="http://www.georgejames.com">

<xsl:include href='gjsForm.xsl'/>

<xsl:template match="Form">
  <xsl:apply-templates select="fileLocation"/>
</xsl:template>

<xsl:template match="fileLocation">

<gjs:form
 title='File Location Settings'
 jsFile='vcset81.js'
 onload='frmMain.selectedLocation[1].focus();'
 save='{/Form/@save}'
 close='{/Form/@close}'
 delete='no'
 print='{/Form/@print}'
 help='{/Form/@help}'
 ok='{/Form/@ok}'
 cancel='{/Form/@cancel}'>


  <gjs:information>
    These settings control how the transfer fileset is named when a transfer to
    a location writes components to F or FX format storage that the location maps to.
  </gjs:information>

<div id='divFileLocation' class='visible' style='min-height: 170px'>
  <gjs:frame>
  <!-- Set up frame column widths -->
  <gjs:columnWidths>
    <gjs:column width='520'/>
  </gjs:columnWidths>

  <gjs:fields>
    <tr>
      <td>
        <table class='formLayoutTable'>
              <tr>
		<gjs:column width='1'/>
                <gjs:column width='160'/>
                <gjs:column width='90'/>
		<gjs:column width='80'/>
                <gjs:column width='80'/>
		<gjs:column width='80'/>
              </tr>
              <tr>
		<td height='30'></td>
                <gjs:caption><label><u>L</u>ocation</label></gjs:caption>
		<gjs:caption><label>File p<u>r</u>efix</label></gjs:caption>
		<gjs:caption><label>Last used file <u>s</u>uffix</label></gjs:caption>
		<gjs:caption><label>File suffix <u>m</u>inimum</label></gjs:caption>
		<gjs:caption><label>File suffix ma<u>x</u>imum</label></gjs:caption>
              </tr>            
        </table>
      </td>
    </tr>
    <tr>
      <td>
        <div class='gridTableOuter' style='height: 98px; width: 560px;'>
          <table class='formLayoutTable'>
          </table>
          <div class='gridTableInner' style='height: 98px;' id='divStatii'>
            <table class='formLayoutTable'>
              <tr>
                <gjs:column width='170'/>
                <gjs:column width='80'/>
                <gjs:column width='80'/>
                <gjs:column width='80'/>
                <gjs:column width='80'/>
              </tr>

              <xsl:call-template name='locDetail'>
                <xsl:with-param name='style' select='"display: none;"'/>
                <xsl:with-param name='lastRow' select='"1"'/> <!-- sic -->
              </xsl:call-template>
              <xsl:apply-templates select='/Form/fileLocation/locationDetails/locDetail' mode='grid'>
                <xsl:sort select='@selectedLocation'/>
                <xsl:with-param name='style' select='""'/>
                <xsl:with-param name='lastRow' select='"0"'/>
              </xsl:apply-templates>
              <xsl:call-template name='locDetail'>
                <xsl:with-param name='style' select='""'/>
                <xsl:with-param name='lastRow' select='"1"'/>
              </xsl:call-template>
            </table>
          </div>
        </div>
      </td>
    </tr>

    <tr>
      <td height='16'></td>
    </tr>

  </gjs:fields>

  <gjs:inputHidden id='revision' value='{/Form/fileLocation/@revision}'/>
  

  </gjs:frame>
</div>
</gjs:form>
</xsl:template>


<xsl:template match='/Form/fileLocation/locationDetails/locDetail' name='locDetail' mode="grid">
  <xsl:param name='style'/>
  <xsl:param name='lastRow'/>
  <tr style='{$style}'
   gjsLastRow='{$lastRow}'>
    <gjs:list1
     row='0'
     id='selectedLocation'
     accesskey='L'
     width='150'
     value='{@selectedLocation}'
     onchange='fnRowChanged(this)'
     readonly='0'>
      <item>
        <label></label>
        <value></value>
      </item>
      <xsl:apply-templates select='/Form/fileLocation/locations/location' mode='list1' />
    </gjs:list1>

    <td>
      <input 
       type='text' 
       size='10'
       maxlength='50' 
       id='pre' 
       name='pre' 
       value='{@pre}' 
       class='input'
       title='Enter a value'
       onChange='fnRowChanged(this);'/>
    </td>

    <td>
      <input 
       type='text' 
       size='10'
       maxlength='10' 
       id='last' 
       name='last' 
       value='{@last}' 
       class='input' 
       title='Enter a numeric value'
       onChange='fnRowChanged(this);'/>
    </td>

    <td>
      <input 
       type='text' 
       size='10'
       maxlength='10' 
       id='min' 
       name='min' 
       value='{@min}' 
       class='input'
       title='Enter a numeric value'
       onChange='fnRowChanged(this);'/>
    </td>

    <td>
      <input 
       type='text' 
       size='10'
       maxlength='10' 
       id='max' 
       name='max' 
       value='{@max}' 
       class='input'
       title='Enter a numeric value'
       onChange='fnRowChanged(this);'/>
    </td>

  </tr>
</xsl:template>

<!-- Location list boxes -->
<xsl:template match='location' mode="list1">
<item>
  <label><xsl:value-of select="@location" /></label>
  <value><xsl:value-of select="@location" /></value>
</item>
</xsl:template>


</xsl:stylesheet>
