<?xml version='1.0' standalone='no'?>
<!DOCTYPE xsl:stylesheet [ <!ENTITY nbsp '&#160;'> ]>
<xsl:stylesheet 
 version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:gjs="http://www.georgejames.com">

<!-- JavaScript Files List
     =========
-->

<xsl:import href='gjsTree.xsl' />
<xsl:include href='ServerLink.xsl' />


<xsl:template match="/ServerLink/Rows">
  <div id='divFolderHeadingCaption'>
    JavaScript Files
  </div>
  <div id='divMainHead'>
    <xsl:call-template name='divMainHead' />
  </div>
  <xsl:call-template name='gjs:tree' />
</xsl:template>


<xsl:template name='divMainHead'>

  	<table class='layoutTable' gjsTreeId='JavaScript_List'>
  	  <tr>

        <xsl:call-template name='gjs:treeMoresMainHeading' />

        <td width='25' style='min-width:25px; max-width:25px; width:25px'></td>

        <xsl:call-template name='gjs:treeColumnHeading'>
          <xsl:with-param name='width' select='"150"'/> 
	  <xsl:with-param name='columnId'>JavaScriptFile</xsl:with-param>
          <xsl:with-param name='caption'>JavaScript File</xsl:with-param>         
          <xsl:with-param name='selected'>ascending</xsl:with-param>
	  <xsl:with-param name='previousColumnResizable'>0</xsl:with-param>
        </xsl:call-template>
  	    
        <xsl:call-template name='gjs:treeColumnHeading'>
          <xsl:with-param name='width' select='"200"'/> 
	  <xsl:with-param name='columnId'>Description</xsl:with-param>
          <xsl:with-param name='caption'>Description</xsl:with-param>         
        </xsl:call-template>
        
        <!--<xsl:call-template name='gjs:treeColumnHeading'>
          <xsl:with-param name='width' select='"1000"'/> 
        </xsl:call-template>
  	    
        <td width='*'></td>-->
      </tr>
    </table>

</xsl:template>



<xsl:template name='leafContent'>

  <!-- Icon for record -->
  <td class='noHighlight' width='25' style='min-width:25px; max-width:25px; width:25px'>
    <img
     src='vcm_record_l.gif'
     width='25'
     height='16'>
    </img>
  </td>

  <td class='treeCell'>
    <div nowrap='nowrap'>
      <xsl:value-of select='jsFile/@jsFile' />
    </div>
  </td>

  <td class='treeCell'>
    <div nowrap='nowrap'>
      <xsl:value-of select='jsFile/@description'/>
    </div>
  </td>
 
  <!-- empty cell to cater for extra column that gives the last real column a right-hand resize handle -->
  <td class='treeCell'>
    <div nowrap='nowrap'>
    </div>
  </td>
 </xsl:template>


<!-- Attributes for each leaf row -->
<xsl:template name='leafRowAttributes'>
	<xsl:param name='rowId'/>
  <xsl:attribute name='tabindex'>0</xsl:attribute>
  <xsl:attribute name='onfocus'>fnItemSelect(this);Class.fnSelect(JavaScript,this)</xsl:attribute>
  <xsl:attribute name='onclick'>fnItemSelect(this);Class.fnSelect(JavaScript,this)</xsl:attribute>
  <xsl:attribute name='oncontextmenu'>fnItemSelect(this);Class.fnSelect(JavaScript,this);fnContextMenu("popItem")</xsl:attribute>
  <xsl:attribute name='gjsItem'><xsl:value-of select='jsFile/@jsFile' /></xsl:attribute>
  <xsl:attribute name='id'><xsl:value-of select='$rowId' />main</xsl:attribute>
	<xsl:if test='/ServerLink/allowedMethods/method[@name="JavaScript.fnOpen"]'>
		<xsl:attribute name='ondblclick'>JavaScript.Item.fnOpen()</xsl:attribute>
	</xsl:if>
</xsl:template>


</xsl:stylesheet>
