<?xml version='1.0' standalone='no'?>
<!DOCTYPE xsl:stylesheet [ <!ENTITY nbsp '&#160;'> ]>
<xsl:stylesheet
 version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:gjs="http://www.georgejames.com">


<!-- If we are making a copy then it is always editable -->
<xsl:variable name='gEditable'>
  <xsl:choose>
    <xsl:when test='/Form/@method="view"'>0</xsl:when>
    <xsl:when test='/Form/@method="copy"'>1</xsl:when>
    <xsl:otherwise><xsl:value-of select='/Form/menu/@editable' /></xsl:otherwise>
  </xsl:choose>
</xsl:variable>


<xsl:include href='gjsForm.xsl'/>


<xsl:template match="Form">
  <xsl:variable name='readonly'>
    <xsl:choose>
      <xsl:when test='@method="view"'>
        <xsl:text>1</xsl:text>
      </xsl:when>          
      <xsl:otherwise>
        <xsl:text>0</xsl:text>
      </xsl:otherwise>          
    </xsl:choose>
  </xsl:variable>

  <xsl:variable name='menu'>
    <xsl:choose>
      <xsl:when test='@method="copy"'></xsl:when>
      <xsl:otherwise><xsl:value-of select='menu/@menu' /></xsl:otherwise>
    </xsl:choose>
  </xsl:variable>

  <xsl:variable name='revision'>
    <xsl:choose>
      <xsl:when test='@method="copy"'></xsl:when>
      <xsl:otherwise><xsl:value-of select='menu/@revision' /></xsl:otherwise>
    </xsl:choose>
  </xsl:variable>


  <gjs:form
   title='Menu'
   width='820'
   jsFile='vc576.js'
   onload='frmMain.menu.focus()'
   save="{@save}"
   close="{@close}" 
   delete="no" 
   print="{@print}" 
   help="{@help}" 
   ok="{@ok}" 
   cancel="{@cancel}">
    <xsl:if test='@method!="copy"'>
      <xsl:attribute name='delete'><xsl:value-of select='@delete' /></xsl:attribute>
    </xsl:if>

    <gjs:information>
      <xsl:if test='@method="copy"'>You are creating a copy of the definition of menu '<xsl:value-of select='menu/@menu'/>'.&nbsp;</xsl:if>
     Menus are used in a number of different places to define a hierarchical set of options that can be selected by the user.&nbsp;
     Most menus are standard application menus whose contents cannot be amended.&nbsp;
     Site-defined menus can be used to override standard menus.&nbsp;
     Do this here for an override applying to all users, or in user definition for per-user overrides.&nbsp;
     Site-defined menu names must either be all uppercase, or must begin with 'vcmy', 'vcmz' or 'vcy'.&nbsp;
    </gjs:information>

    <div id='divMenu' class='visible'>
      <gjs:frame>
        <!-- Set up frame column widths -->
        <gjs:columnWidths>
          <gjs:column width='150'/>
          <gjs:column width='550'/>
        </gjs:columnWidths>

        <gjs:fields>

          <gjs:input
           id='menu'
           accesskey='M'
           size='20'
           maxlength='40'
           value='{$menu}'>
            <xsl:if test='$gEditable="0"'>
              <xsl:attribute name='readonly'>1</xsl:attribute>        
            </xsl:if>
            <label><u>M</u>enu</label>
            <hint>Enter a name for this menu</hint>
          </gjs:input>

          <gjs:input
           id='description'
           accesskey='E'
           size='60'
           maxlength='200'
           value='{menu/@description}'>
            <xsl:if test='$gEditable="0"'>
              <xsl:attribute name='readonly'>1</xsl:attribute>
            </xsl:if>
            <label>D<u>e</u>scription</label>
            <hint>Enter a free text description of this menu</hint>
          </gjs:input>

          <tr>
            <td height='16'></td>
          </tr>

          <tr>
            <td colspan='2'>
              <table class='formLayoutTable' border='0'>
                <tr>
                  <gjs:column width='30'/>
                  <gjs:column width='110'/>
                  <gjs:column width='158'/>
                  <gjs:column width='70'/>
                  <gjs:column width='320'/>
                  <gjs:column width='70'/>
                </tr>
                <tr>
                  <td height='16'></td>
                  <gjs:caption><label>Captio<u>n</u></label></gjs:caption>
                  <gjs:caption><label><u>T</u>ooltip</label></gjs:caption>
                  <gjs:caption><label>T<u>y</u>pe</label></gjs:caption>
                  <gjs:caption><label>Method and ar<u>g</u>uments</label></gjs:caption>
                  <gjs:caption><label><u>R</u>eturn code</label></gjs:caption>
                </tr>
              </table>
            </td>
          </tr>
          <tr>
            <td colspan='2'>
              <div class='gridTableOuter' style='height: 195px;'>
                <table class='formLayoutTable'>
                </table>
                <div class='gridTableInner' style='height: 195px;' id='divMenuOptions'>
                  <table class='formLayoutTable'>
                    <tr>
                      <gjs:column width='25'/>
                      <gjs:column width='110'/>
                      <gjs:column width='158'/>
                      <gjs:column width='70'/>
                      <gjs:column width='320'/>
                      <gjs:column width='70'/>
                    </tr>

                    <xsl:apply-templates select='menu/menuOptions'/>

                  </table>
                </div>
              </div>
            </td>
          </tr>


          <tr>
            <td height='16'></td>
          </tr>

          <gjs:input
           id='accessCodes'
           accesskey='A'
           size='60'
           maxlength='1000'
           value='{menu/@accessCodes}'
           readonly='{$readonly}'>
            <label><u>A</u>ccess rights</label>
            <hint>Enter a comma separated list of access rights. Any user with any one of these rights will be permitted to access this menu.</hint>
          </gjs:input>

          <tr>
            <td height='16'></td>
          </tr>

          <gjs:list1
            id='systemWideOverrideMenu'
            accesskey='W'
            width='200'
            value='{menu/@systemWideOverrideMenu}'
            readonly='0'>
      	    <xsl:if test='$readonly="1"'>
      	      <xsl:attribute name='disabled'/>  
      	    </xsl:if>
            <label>System-<u>w</u>ide override menu</label>
            <hint>Select another menu that will be displayed for all users in place of this menu. For per-user overrides, go to user maintenance.</hint>
            <item>
              <label></label>
              <value></value>
            </item>
            <xsl:apply-templates select='/Form/menus/menu' mode='list1'/>
          </gjs:list1>

        </gjs:fields>

        <gjs:inputHidden id='revision' value='{$revision}'/>
        <gjs:inputHidden id='oldMenu' value='{$menu}'/>

      </gjs:frame>
    </div>
  </gjs:form>

</xsl:template>


<xsl:template match='/Form/menu/menuOptions'>
  <!-- First row is a hidden row that is a template for new rows -->
  <xsl:call-template name='menuOption'>
    <xsl:with-param name='style' select='"display: none;"'/>
    <xsl:with-param name='lastRow' select='"1"'/> <!-- sic -->
  </xsl:call-template>

  <!-- Next we render any data rows -->
  <xsl:apply-templates select='menuOption' mode='grid'>
    <xsl:with-param name='lastRow' select='"0"'/>
  </xsl:apply-templates>
  
<!-- Finally the last row which, when filled, will generate a new row from the template -->
  <xsl:call-template name='menuOption'>
    <xsl:with-param name='lastRow' select='"1"'/>
  </xsl:call-template>
</xsl:template>


<xsl:template match='/Form/menu/menuOptions/menuOption' name='menuOption' mode="grid">
  <xsl:param name='style'/>
  <xsl:param name='lastRow'/>
  <tr 
   style='{$style}'
   gjsLastRow='{$lastRow}'>
    <td>
      <img src='vcm_record.gif'
       height='16'
       width='25'
       >
        <xsl:if test='$gEditable="1"'>
          <xsl:attribute name='onclick'>Form.fnRowSelect(this.parentNode.parentNode,event)</xsl:attribute>        
          <xsl:attribute name='title'>Enter one or more menu options for this menu.  To resequence, click row icon and then use cursor keys.</xsl:attribute>        
        </xsl:if>
       </img>
    </td>
    <td>
      <input 
       type='text' 
       size='13'
       maxlength='40' 
       name='caption' 
       value='{@caption}' 
       class='input' 
       onChange='Form.fnRowChanged(this.parentNode.parentNode)'>
        <xsl:if test='$gEditable="0"'>
          <xsl:attribute name='readonly'>1</xsl:attribute>
          <xsl:attribute name='class'>inputDisabled</xsl:attribute>
        </xsl:if>
      </input>
    </td>
    <td>
      <input 
       type='text' 
       size='20'
       maxlength='200' 
       name='optionDescription' 
       value='{@description}' 
       class='input' 
       onChange='Form.fnRowChanged(this.parentNode.parentNode)'>
        <xsl:if test='$gEditable="0"'>
          <xsl:attribute name='readonly'>1</xsl:attribute>
          <xsl:attribute name='class'>inputDisabled</xsl:attribute>
        </xsl:if>
      </input>
    </td>
    
    <!-- gjs:list1 generates two table cells -->
      <gjs:list1
       row='0'
       name='type'
       accesskey='T'
       width='70'
       value='{@type}'
       onChange='Form.fnRowChanged(this.parentNode.parentNode)'>
        <xsl:if test='$gEditable="0"'>
          <xsl:attribute name='disabled'>disabled</xsl:attribute>
          <xsl:attribute name='class'>inputDisabled</xsl:attribute>
        </xsl:if>
        <hint>Select the type of this menu option</hint>
        <item>
          <label></label>
          <value></value>
        </item>
        <item>
          <label>Normal</label>
          <value>0</value>
        </item>
        <item>
          <label>Folder</label>
          <value>1</value>
        </item>
      </gjs:list1>

    <td>
      <input 
       type='text' 
       size='45'
       maxlength='400' 
       name='func' 
       value='{@function}' 
       class='input' 
       onChange='Form.fnRowChanged(this.parentNode.parentNode)'>
        <xsl:if test='$gEditable="0"'>
          <xsl:attribute name='readonly'>1</xsl:attribute>
          <xsl:attribute name='class'>inputDisabled</xsl:attribute>
        </xsl:if>
      </input>
    </td>

    <td>
      <input 
       type='text' 
       size='7'
       maxlength='5' 
       name='returnCode' 
       value='{@returnCode}' 
       class='input' 
       onChange='Form.fnRowChanged(this.parentNode.parentNode)'>
        <xsl:if test='$gEditable="0"'>
          <xsl:attribute name='readonly'>1</xsl:attribute>
          <xsl:attribute name='class'>inputDisabled</xsl:attribute>
        </xsl:if>
      </input>
    </td>


  </tr>
</xsl:template>


<!-- Menu list boxes -->
<xsl:template match='/Form/menus/menu' mode="list1">
<item>
  <label><xsl:value-of select="@menu" /></label>
  <value><xsl:value-of select="@menu" /></value>
</item>
</xsl:template>


</xsl:stylesheet>
