// jQueryUI Menu
//
// Each menu panel is turned into a jQueryUI Menu widget when fnDivMenuResult() get called (in vc700.js)

var menu_open = false; // Stores id of currently open menu-bar (i.e. first-level) menu
var menu_current = false; // Stores id of currently focused menu, which is where shortcut (underlined) letter need to be looked for
var highlighted_option = false;
var activeMenu = false; // Stores the popmenu element

Menubar = {};

Menubar.fnShowMenuPanel = function(id) {
	if (menu_open != id + '-panel') {
		menu_open = id + '-panel';
		var l = $('#' + id).position().left + 2 + 'px';
		$('#' + id + '-panel').css({
			'left':l,
			'display':'block'
		});
	}
	$('#' + id).addClass('menu-root-open');
	menu_current = menu_open;
}

Menubar.fnHideMenuPanel = function(id) {
	$('#' + id).css('display','none');
	menu_open = false;
  menu_current = false;
  $('#' + id).menu('collapseAll', null, true);
	highlighted_option = false;
	
	$('#' + id.replace('-panel','')).removeClass('menu-root-open');
}

Menubar.fnTransformDivMenu = function() {
	//
	// Transform menubar HTML created by jQUIMenu.xsl into jQueryUI menu panels
	$('.menu-panel, .popmenu-panel').menu();
	//
	// Attach function to onclick event handler of the menu bar options
	$('.menu-root').on('click',function() {
      // Update the greyed-out status of all items of all menu panels in the menu bar hierarchy. It applies to all panels so that they are up-to-date when the user moves between the menus
	  $('.menu-panel .ui-menu-item').each(function() {
		// For each item, check whether to grey out or not
		if (($(this).data('disabled') == 'true') || (($(this).data('methodname') != "") &&(eval('typeof('+$(this).data('methodname')+')') != 'function'))) {
			$(this).addClass('ui-state-disabled');
		} else if (($(this).data('methodname') == "") || (eval('typeof('+$(this).data('methodname')+'$MenuState'+')') != 'function')) {
			$(this).removeClass('ui-state-disabled');
		} else if (eval($(this).data('methodname')+'$MenuState()')){
			$(this).removeClass('ui-state-disabled');
    } else {
			$(this).addClass('ui-state-disabled');
    }
	  });
	});
	//
	// Loop through each menu root item
	$('.menu-root').each(function() {
		//
		// If there is an Alt keyboard shortcut (access key) defined, wrap the accesskey letter in a span that styles it with an underline
		var p = $(this).data("accesskeypos"); // Get accesskey position
		if (p > -1) { // If an access key is defined
			Menubar.fnStyleAccessKey(this, p);
		}
	});
	//
	// Loop through each menu item
	$('.ui-menu-item > a').each(function() {
		//
		// If there is an Alt keyboard shortcut (access key) defined, wrap the accesskey letter in a span that styles it with an underline
		var p = $(this).parent().data("accesskeypos"); // Get accesskey position
		if (p > -1) { // If an access key is defined
			Menubar.fnStyleAccessKey(this, p);
		}
		//
		// If there is a Ctrl keyboard shortcut listed for this menu item, move the shortcut helper text to the right by wrapping the two parts of the menu option in span tags
		// E.g.: <span class="menu-item-shortcut">New</span><span class="menu-item-text">(Ctrl+N)</span>
		var s = $(this).html().indexOf('(');
		if (s > -1) {
			var txt = '<span class="menu-item-shortcut">' + $(this).html().substr(s) + '</span><span class="menu-item-text">' + $(this).html().substr(0,s) + '</span>';
			$(this).html(txt);
		}
	});
}

Menubar.fnAccessKeyHandler = function(e) {
	//
	// Detect shortcut for opening a menu
	if (e.altKey) {
		$('.menu-root').each(function() {
			var p = $(this).data('accesskeypos');
			if (e.which == $(this).text().substr(p,1).toUpperCase().charCodeAt(0) || e.which == $(this).text().substr(p,1).toLowerCase().charCodeAt(0)) {
				if (menu_open) Menubar.fnHideMenuPanel(menu_open);
				$(this).trigger('click');
			}
		});
	}
	//
	// Navigating open menus
	if (menu_open) {
		Menubar.fnKeyboardNavigateOpenMenu(e);
	} else if (activeMenu) {
		Menubar.fnKeyboardNavigatePopupMenu(e);
	}
}

Menubar.fnKeyboardNavigateOpenMenu = function(e) {
	var menu_next;
	//
	// Handler for keyboard arrow navigation of the menu bar (arrow keycodes are 37-40)
	// Left = 37; Up = 38; Right = 39; Down = 40;
	if (e.which >= 37 && e.which <= 40) {
		switch(e.which) {
			// Left
			case 37:
				if (highlighted_option && $(highlighted_option).parent().hasClass('submenu')) {
					highlighted_option = $(highlighted_option).parent().parent().find('.submenu').parent();
					$(highlighted_option).parent().menu().menu('focus',null,highlighted_option);          
				} else {
					// CLOSE THIS MENU AND OPEN THE ONE TO THE LEFT (OR OPEN THE LAST ONE IF THIS IS THE FIRST ON THE ROW)
					if (highlighted_option) $(highlighted_option).parent().menu('blur');
					menu_next = $('#' + menu_open).prevAll("ul.ui-menu-panel:not(.ui-state-disabled)").first();
					if (!menu_next.length) menu_next = $('#' + menu_open).parent().children("ul.ui-menu-panel:not(.ui-state-disabled)").last();
					menu_next = menu_next[0].id.replace('-panel','');
					Menubar.fnHideMenuPanel(menu_open);
					Menubar.fnShowMenuPanel(menu_next);
				}
				break;
			// Up
			case 38:
				if (highlighted_option) {
					$(highlighted_option).trigger("mouseout");
					if (highlighted_option[0] == $('#' + menu_open).children("li:not(.ui-state-disabled, .ui-menu-divider)").first()[0]) {
						highlighted_option = $('#' + menu_open).children("li:not(.ui-state-disabled, .ui-menu-divider)").last().trigger("mouseover");
					} else {
						highlighted_option = $(highlighted_option).prevAll("li:not(.ui-state-disabled, .ui-menu-divider)").first().trigger("mouseover");
					}
				} else {
					highlighted_option = $('#' + menu_open).children("li:not(.ui-state-disabled, .ui-menu-divider)").last().trigger("mouseover");
				}
				$(highlighted_option).parent().menu('focus',null,$(highlighted_option));
				break;
			// Right
			case 39:
				if (highlighted_option && $(highlighted_option).find('.submenu').length) {
          $(highlighted_option).trigger("mouseover");
					menu_current = $(highlighted_option).find('.submenu')[0].id;
					highlighted_option = $(highlighted_option).find('.submenu').children("li:not(.ui-state-disabled, .ui-menu-divider)").first();
          
					// Put focus onto SUBmenu
					$(highlighted_option).parent().menu().menu('focus',null,$(highlighted_option));
				} else {
					// CLOSE THIS MENU AND OPEN THE ONE TO THE RIGHT (OR OPEN THE FIRST ONE IF THIS IS THE LAST ON THE ROW)
					if (highlighted_option) $(highlighted_option).parent().menu('blur');
					menu_next = $('#' + menu_open).nextAll("ul.ui-menu-panel:not(.ui-state-disabled)").first();
					if (!menu_next.length) menu_next = $('#' + menu_open).parent().children("ul.ui-menu-panel:not(.ui-state-disabled)").first();
					menu_next = menu_next[0].id.replace('-panel','');
					Menubar.fnHideMenuPanel(menu_open);
					Menubar.fnShowMenuPanel(menu_next);
				}
				break;
			// Down
			case 40:
				if (highlighted_option) {
					$(highlighted_option).trigger("mouseout");
					if (highlighted_option[0] == $('#' + menu_open).children("li:not(.ui-state-disabled, .ui-menu-divider)").last()[0]) {
						highlighted_option = $('#' + menu_open).children("li:not(.ui-state-disabled, .ui-menu-divider)").first().trigger("mouseover");
					} else {
						highlighted_option = $(highlighted_option).nextAll("li:not(.ui-state-disabled, .ui-menu-divider)").first().trigger("mouseover");
					}
				} else {
					highlighted_option = $('#' + menu_open).children("li:not(.ui-state-disabled, .ui-menu-divider)").first().trigger("mouseover");
				}
				$(highlighted_option).parent().menu('focus',null,$(highlighted_option));
				break;
		}
    e.stopPropagation();
    e.preventDefault();
	} else if (e.which == 27) {
		if (highlighted_option && $(highlighted_option).parent().hasClass('submenu')) {  
			highlighted_option = $(highlighted_option).parent().parent().find('.submenu').parent();
			$(highlighted_option).parent().menu().menu('focus',null,highlighted_option);          
		} else {
    		Menubar.fnHideMenuPanel(menu_open);
    }
	} else if (e.which == 13) {
    if (highlighted_option) {
			if ($(highlighted_option).find('.submenu').length) {
				$(highlighted_option).trigger("mouseover");
				menu_current = $(highlighted_option).find('.submenu')[0].id;
				highlighted_option = $(highlighted_option).find('.submenu').children("li:not(.ui-state-disabled, .ui-menu-divider)").first();
        
				// Put focus onto SUBmenu
				$(highlighted_option).parent().menu().menu('focus',null,$(highlighted_option));
			} else {
		    $(highlighted_option).trigger('click').trigger('mousedown');
        Menubar.fnHideMenuPanel(menu_open);
      }
    }
	} else {
		//
		// Detect shortcut for choosing a menu item from currently-focused menu (could be a submenu)
		$('#' + menu_current + ' > li > a').each(function() {
			var p = $(this).parent().data('accesskeypos');
			if (($(this).children(".menu-item-text")
					&& (e.which == $(this).children(".menu-item-text").text().substr(p,1).toUpperCase().charCodeAt(0) 
						|| e.which == $(this).children(".menu-item-text").text().substr(p,1).toLowerCase().charCodeAt(0)))
				|| (e.which == $(this).text().substr(p,1).toUpperCase().charCodeAt(0) 
						|| e.which == $(this).text().substr(p,1).toLowerCase().charCodeAt(0))) {
  			if ($(this).parent().find('.submenu').length) {
  				$(this).parent().trigger("mouseover");
  				menu_current = $(this).parent().find('.submenu')[0].id;
  				highlighted_option = $(this).parent().find('.submenu').children("li:not(.ui-state-disabled, .ui-menu-divider)").first();
          
  				// Put focus onto SUBmenu
  				$(highlighted_option).parent().menu().menu('focus',null,$(highlighted_option));
  			} else {
  				$(this).parent().trigger('click').trigger('mousedown');
        }
			}
		});
	}
}

Menubar.fnKeyboardNavigatePopupMenu = function(e) {
	var menu_next;
	//
	// Handler for keyboard arrow navigation of the popup menu (arrow keycodes are 37-40)
	// Left = 37; Up = 38; Right = 39; Down = 40;
	if (e.which >= 37 && e.which <= 40) {
		switch(e.which) {
			// Left
			case 37:
				break;
			// Up
			case 38:
				if (highlighted_option) {
					$(highlighted_option).trigger("mouseout");
					if (highlighted_option[0] == $(activeMenu).children("li:not(.ui-state-disabled, .ui-menu-divider)").first()[0]) {
						highlighted_option = $(activeMenu).children("li:not(.ui-state-disabled, .ui-menu-divider)").last().trigger("mouseover");
					} else {
						highlighted_option = $(highlighted_option).prevAll("li:not(.ui-state-disabled, .ui-menu-divider)").first().trigger("mouseover");
					}
				} else {
					highlighted_option = $(activeMenu).children("li:not(.ui-state-disabled, .ui-menu-divider)").last().trigger("mouseover");
				}
				break;
			// Right
			case 39:
				break;
			// Down
			case 40:
				if (highlighted_option) {
					$(highlighted_option).trigger("mouseout");
					if (highlighted_option[0] == $(activeMenu).children("li:not(.ui-state-disabled, .ui-menu-divider)").last()[0]) {
						highlighted_option = $(activeMenu).children("li:not(.ui-state-disabled, .ui-menu-divider)").first().trigger("mouseover");
					} else {
						highlighted_option = $(highlighted_option).nextAll("li:not(.ui-state-disabled, .ui-menu-divider)").first().trigger("mouseover");
					}
				} else {
					highlighted_option = $(activeMenu).children("li:not(.ui-state-disabled, .ui-menu-divider)").first().trigger("mouseover");
				}
				break;
		}
	} else if (e.which == 27) {
		Menubar.fnjQUIHideMenu(activeMenu);
	} else {
		//
		// Detect shortcut for choosing a menu item from an open menu  TODO
		$('#' + menu_open + ' > li > a').each(function() {
			var p = $(this).parent().data('accesskeypos');
			if (($(this).children(".menu-item-text")
					&& (e.which == $(this).children(".menu-item-text").text().substr(p,1).toUpperCase().charCodeAt(0) 
						|| e.which == $(this).children(".menu-item-text").text().substr(p,1).toLowerCase().charCodeAt(0)))
				|| (e.which == $(this).text().substr(p,1).toUpperCase().charCodeAt(0) 
						|| e.which == $(this).text().substr(p,1).toLowerCase().charCodeAt(0))) {
				$(this).parent().trigger('click').trigger('mousedown');
			}
		});
	}
}

Menubar.fnStyleAccessKey = function(elem, p) {
	var txt = $(elem).text(); // Get text content of menu option 
	txt = txt.substr(0,p) + '<span class="accesskey">' + txt.substr(p,1) + '</span>' + txt.substr(p+1); // Wrap accesskey letter in span tag
	// Replace the text content of the element with the html we have just created
	var html = $(elem).find('*');
	$(elem).html(html);
	$(elem).append(txt);
}

Menubar.fnjQUIMenuPopup = function(el,e) {
	el = $(el);
	// Hide any open popmenus
	if (activeMenu) {
		Menubar.fnjQUIHideMenu(activeMenu);
	}
	// Set position
	el.css('top',e.pageY+'px');
	el.css('left',e.pageX+'px');
	// Disable options if they're unavailable
	$('.popmenu-panel .ui-menu-item').each(function() {
		if (($(this).data('disabled') == 'true') || (($(this).data('methodname') != "") &&(eval('typeof('+$(this).data('methodname')+')') != 'function'))) {
			$(this).addClass('ui-state-disabled');
		} else if (($(this).data('methodname') == "") || (eval('typeof('+$(this).data('methodname')+'$MenuState'+')') != 'function')) {
			$(this).removeClass('ui-state-disabled');
		} else if (eval($(this).data('methodname')+'$MenuState()')){
			$(this).removeClass('ui-state-disabled');
    } else {
			$(this).addClass('ui-state-disabled');
    }
	});
	// Show popmenu
	activeMenu = el;
	$(el).css('display','block');
	// Reposition if too close to edges (can only do this after we have displayed it)
	if (el.offset().top + el.height() > $(window).height()) el.css('top',(e.pageY-el.height())+'px');
	if (el.offset().left + el.width() > $(window).width()) el.css('left',(e.pageX-el.width())+'px');

}

Menubar.fnjQUIHideMenu = function(el) {
	$(el).css('display','none');
	activeMenu = false;
	highlighted_option = false;
}

$(function() {
	$(document).on('mousedown',function(e) {
		//Hides a menu panel unless its root menu button has been clicked again, or unless it has a submenu
		if (menu_open) {
			if (e.target.parentElement == null || e.target.parentElement.parentElement == null || (e.target.id != menu_open.replace('-panel','') && !(e.target.getAttribute('data-methodname') == "") && !(e.target.parentElement.getAttribute('data-methodname') == ""))) {
				Menubar.fnHideMenuPanel(menu_open);
			}
		}
		//Hides a popmenu
		if (activeMenu) {
			Menubar.fnjQUIHideMenu(activeMenu);
		}
	});
	$(document).on('mousemove',function(e){
		if (menu_open) {
			if ((e.target.id != menu_open.replace('-panel','')) && (e.target.className == 'menu-root')) {
				Menubar.fnHideMenuPanel(menu_open);
				Menubar.fnShowMenuPanel(e.target.id);
			}
		}
	});
});
