<?xml version='1.0' standalone='no'?>
<!DOCTYPE xsl:stylesheet [ <!ENTITY nbsp '&#160;'> ]>
<xsl:stylesheet
 version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:gjs="http://www.georgejames.com">

<xsl:include href='gjsForm.xsl'/>

<xsl:template match="Form">
	<xsl:apply-templates select="locationsAndRoutes"/>
</xsl:template>

<xsl:template match="/Form/locationsAndRoutes">

<gjs:form
 title='Locations &amp; Routes Diagram'
 jsFile='Report_LocationsAndRoutes_Form.js'
 onload='fnLoad();'
 save='no'
 close='no'
 delete='no'
 print='{/Form/@print}'
 help='{/Form/@help}'
 ok='{/Form/@ok}'
 cancel='{/Form/@cancel}'>

	<gjs:information>
		This report produces a Locations &amp; Routes Diagram (LRD) by generating a GraphML file that 
		you render using the free yEd graph editor from yWorks. &nbsp;Optionally use the Filters tab to limit
		the locations and routes that are included. &nbsp;Items in a filter column combine as "OR", and the
		columns combine as "AND".
	</gjs:information>
	<br/>
  
  <gjs:tabStrip>
    <gjs:tabStripTab
     id='tabInstructions'
     accesskey='I'
     divId='divInstructions'>
      <u>I</u>nstructions
    </gjs:tabStripTab>
    <gjs:tabStripTab
     id='tabTips'
     accesskey='T'
     divId='divTips'>
      <u>T</u>ips
    </gjs:tabStripTab>
    <gjs:tabStripTab
     id='tabFilters'
     accesskey='F'
     divId='divFilters'>
      <u>F</u>ilters
    </gjs:tabStripTab>
  </gjs:tabStrip>

  <!-- The Instructions tab contents -->
	<div id='divInstructions' class='tabPanelVisible' style='height: 360px'>
    <gjs:frame>
	    <div class='caption' style='margin-right: 20px;'>
			  <ol>
			    <li>If yEd is not already installed, download it from
					 <a href='http://www.yworks.com' target='_blank'>http://www.yworks.com</a>
					 and install it, opting to associate the .graphml extension with yEd.
					</li>
					<li>Click <i>OK</i> below to generate and download the GraphML file.&nbsp;&nbsp;That action will close
					 this window, so you may want to use the <i>Print</i> button first to obtain a copy of the
					 subsequent instructions.&nbsp;&nbsp;Alternatively, reopen the dialog a second time.
					</li>
					<li>When prompted by your browser, open the file in yEd.&nbsp;&nbsp;Alternatively, save it
					 for later use.
					</li>
					<li>In yEd use <i>Tools\Fit Node to Label</i>. Suggested values for this operation are:
					  <ul>
						  <li>Act on Selection Only; Adapt to Maximum Node; Ignore Width; Ignore Height: unchecked</li>
						  <li>Horizontal Space: 5</li>
						  <li>Minimum Width: 10</li>
						  <li>Vertical Space: 5</li>
						  <li>Minimum Height: 45</li>
					  </ul>
					</li>
					<li>Use <i>Layout\Orthogonal\Classic</i>. Suggested values are:
					  <ul>
						  <li>Layout Style: Node Boxes (Size Fixed)</li>
						  <li>Length Reduction; Crossing Postprocessing; Minimize Perceived Bends; Use Randomization: checked</li>
						  <li>Edge Labeling: None</li>
					  </ul>
					</li>
				</ol>
			</div>
		</gjs:frame>
	</div>
	
  <!-- The Tips tab contents -->
	<div id='divTips' class='tabPanelHidden' style='height: 360px'>
		<gjs:frame>
	    <div class='caption' style='margin-right: 20px;'>
			  <ul>
			    <li>Make route crossings clearer by setting a <i>Bridge Style</i> on the <i>Display</i>
					 tab of <i>File\Preferences</i>.</li>
				  <li>Select a location node, then use one of the <i>Context Views</i> from the <i>Windows</i> menu.&nbsp;&nbsp;
				   <i>Neighbourhood</i> focuses on routes to and from the location.&nbsp;&nbsp;
					 <i>Predecessors</i> shows workflow to the location.&nbsp;&nbsp;
					 <i>Successors</i> shows workflow from the location.
					</li>
					<li><i>Structure View</i> pane contents are easier to interpret when its dropdown is set to 'PlainText'.
					</li>
				  <li>If you have a mousewheel, use it to zoom the diagram.</li>
				  <li>Panning around the diagram can easily be done by dragging the white rectangle
				   within the <i>Overview</i> pane (opened using <i>Windows\Overview</i>).&nbsp;&nbsp;
					 Dragging the lower right corner of the same rectangle alters diagram zoom.
					</li>
					<li><i>Local Zoom</i>, accessed off the toolbar or via the <i>View</i> menu, assists exploration of
					 a large zoomed-out diagram.
					</li>
			  </ul>
			</div>
		</gjs:frame>
	</div>
     
  <!-- The Filters tab contents -->
  <div id='divFilters' class='tabPanelHidden' style='height: 360px'>
    <gjs:frame>
      <!-- Set up frame column widths -->
      <gjs:columnWidths>
        <gjs:column width='200'/>
        <gjs:column width='200'/>
        <gjs:column width='180'/>
      </gjs:columnWidths>
  
      <gjs:fields>
        <gjs:checkbox
         id='chkTemplates'
         accesskey='T'
         checked='1'>
          <label>Include <u>t</u>emplates?</label>
          <hint>Check to include template locations and routes, i.e. ones defined using variables</hint>
        </gjs:checkbox>
        <gjs:checkbox
         id='chkDerivatives'
         accesskey='D'
         checked='0'>
          <label>Include <u>d</u>erivatives?</label>
          <hint>Check to include locations and routes that were derived from templates</hint>
        </gjs:checkbox>
        <gjs:checkbox
         id='chkDisabledRoutes'
         accesskey='S'
         checked='0'>
          <label>Include di<u>s</u>abled routes?</label>
          <hint>Check to include disabled routes. Such a route will show its function code struck through on the diagram</hint>
        </gjs:checkbox>
      <tr>
        <td colspan='3'>
          <hr/>
        </td>
			</tr>
      <tr>
        <gjs:caption for='divSystems' accesskey='Y'>
          <label>
            S<u>y</u>stems
          </label>
        </gjs:caption>
        <gjs:caption for='divAccessRights' accesskey='A'>
          <label>
            <u>A</u>ccess Rights
          </label>
        </gjs:caption>
        <gjs:caption for='divLocationClasses' accesskey='L'>
          <label>
            <u>L</u>ocation Lists
          </label>
        </gjs:caption>
      </tr>
      <tr>
        <td height='8'></td>
      </tr>
  
      <tr>
        <td>
          <div class='gridTableOuter' style='height: 230px; width: 175px;'>
            <table class='formLayoutTable'>
            </table>
            <div class='gridTableInner' style='height: 230px;' id='divSystems'>
              <table class='formLayoutTable'>
                <tr>
                  <gjs:column width='170'/>
                </tr>
  
                <xsl:apply-templates select='/Form/systems'>
								</xsl:apply-templates>
  
              </table>
            </div>
          </div>
        </td>
        <td>
          <div class='gridTableOuter' style='height: 230px; width: 175px;'>
            <table class='formLayoutTable'>
            </table>
            <div class='gridTableInner' style='height: 230px;' id='divAccessRights'>
              <table class='formLayoutTable'>
                <tr>
                  <gjs:column width='170'/>
                </tr>
  
                <xsl:apply-templates select='/Form/accessRights'>
								</xsl:apply-templates>
  
              </table>
            </div>
          </div>
        </td>
        <td>
          <div class='gridTableOuter' style='height: 230px; width: 175px;'>
            <table class='formLayoutTable'>
            </table>
            <div class='gridTableInner' style='height: 230px;' id='divLocationClasses'>
              <table class='formLayoutTable'>
                <tr>
                  <gjs:column width='170'/>
                </tr>
  
                <xsl:apply-templates select='/Form/locationClasses'>
								</xsl:apply-templates>
  
              </table>
            </div>
          </div>
        </td>
      </tr>
    </gjs:fields>
    </gjs:frame>
  </div>
  
    <!-- Leave some space after the panels and before the buttons -->
    <table><tr><td height='6px'></td></tr></table>
</gjs:form>

</xsl:template>

<xsl:template match='/Form/systems'>

  <!-- First row is a hidden row that is a template for new rows -->
  <xsl:call-template name='system'>
    <xsl:with-param name='display' select='"0"'/>
    <xsl:with-param name='lastRow' select='"1"'/> <!-- sic -->
  </xsl:call-template>

  <!-- Finally the last row which, when filled, will generate a new row from the template -->
  <xsl:call-template name='system'>
    <xsl:with-param name='lastRow' select='"1"'/>
  </xsl:call-template>

</xsl:template>

<xsl:template name='system'>
  <xsl:param name='display' select='"1"'/>
  <xsl:param name='lastRow' select='"0"'/>
  <tr 
   title='Select which systems the locations in the report must belong to'
   gjsLastRow='{$lastRow}'>
    <xsl:if test='$display="0"'>
      <xsl:attribute name='style'>display: none;</xsl:attribute>  
    </xsl:if>
    <td>
      <table>
        <gjs:list1
         name='system'
         accesskey='P'
         width='160'
         value=''
         onchange='Form.fnRowChanged(this.parentNode.parentNode.parentNode.parentNode.parentNode.parentNode)'>
					<hint>Select a system that the locations in the report must belong to</hint>
					<item>
						<label></label>
						<value></value>
					</item>
					<xsl:apply-templates select='/Form/systems/system' mode='list1' />
        </gjs:list1>
      </table>
    </td>
  </tr>
</xsl:template>

<!-- Systems list boxes -->
<xsl:template match='/Form/systems/system' mode="list1">
<item>
  <label><xsl:value-of select="@system" /></label>
  <value><xsl:value-of select="@system" /></value>
</item>
</xsl:template>

<xsl:template match='/Form/accessRights'>

  <!-- First row is a hidden row that is a template for new rows -->
  <xsl:call-template name='accessRight'>
    <xsl:with-param name='display' select='"0"'/>
    <xsl:with-param name='lastRow' select='"1"'/> <!-- sic -->
  </xsl:call-template>

  <!-- Finally the last row which, when filled, will generate a new row from the template -->
  <xsl:call-template name='accessRight'>
    <xsl:with-param name='lastRow' select='"1"'/>
  </xsl:call-template>

</xsl:template>

<xsl:template name='accessRight'>
  <xsl:param name='display' select='"1"'/>
  <xsl:param name='lastRow' select='"0"'/>
  <tr 
   title='Select which access rights the locations and routes in the report must require'
   gjsLastRow='{$lastRow}'>
    <xsl:if test='$display="0"'>
      <xsl:attribute name='style'>display: none;</xsl:attribute>  
    </xsl:if>
    <td>
      <table>
        <gjs:list1
         name='accessRight'
         accesskey='P'
         width='160'
         value=''
         onchange='Form.fnRowChanged(this.parentNode.parentNode.parentNode.parentNode.parentNode.parentNode)'>
					<hint>Select an access right that the locations and routes in the report must require</hint>
					<item>
						<label></label>
						<value></value>
					</item>
					<xsl:apply-templates select='/Form/accessRights/accessRight' mode='list1' />
        </gjs:list1>
      </table>
    </td>
  </tr>
</xsl:template>

<!-- Access Rights list boxes -->
<xsl:template match='/Form/accessRights/accessRight' mode="list1">
<item>
  <label><xsl:value-of select="@accessRight" /></label>
  <value><xsl:value-of select="@accessRight" /></value>
</item>
</xsl:template>


<xsl:template match='/Form/locationClasses'>

  <!-- First row is a hidden row that is a template for new rows -->
  <xsl:call-template name='locationClass'>
    <xsl:with-param name='display' select='"0"'/>
    <xsl:with-param name='lastRow' select='"1"'/> <!-- sic -->
  </xsl:call-template>

  <!-- Finally the last row which, when filled, will generate a new row from the template -->
  <xsl:call-template name='locationClass'>
    <xsl:with-param name='lastRow' select='"1"'/>
  </xsl:call-template>

</xsl:template>

<xsl:template name='locationClass'>
  <xsl:param name='display' select='"1"'/>
  <xsl:param name='lastRow' select='"0"'/>
  <tr 
   title='Select which lists the locations in the report must belong to'
   gjsLastRow='{$lastRow}'>
    <xsl:if test='$display="0"'>
      <xsl:attribute name='style'>display: none;</xsl:attribute>  
    </xsl:if>
    <td>
      <table>
        <gjs:list1
         name='locationClass'
         accesskey='P'
         width='160'
         value=''
         onchange='Form.fnRowChanged(this.parentNode.parentNode.parentNode.parentNode.parentNode.parentNode)'>
					<hint>Select a list that the locations in the report must belong to</hint>
					<item>
						<label></label>
						<value></value>
					</item>
					<xsl:apply-templates select='/Form/locationClasses/locationClass' mode='list1' />
        </gjs:list1>
      </table>
    </td>
  </tr>
</xsl:template>

<!-- Location Lists list boxes -->
<xsl:template match='/Form/locationClasses/locationClass' mode="list1">
<item>
  <label><xsl:value-of select="@locationClass" /></label>
  <value><xsl:value-of select="@locationClass" /></value>
</item>
</xsl:template>

</xsl:stylesheet>
