<?xml version='1.0' standalone='no'?>
<!DOCTYPE xsl:stylesheet [ <!ENTITY nbsp '&#160;'> ]>
<xsl:stylesheet
 version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:msxsl="urn:schemas-microsoft-com:xslt"
 xmlns:gjs="http://www.georgejames.com">

<xsl:include href='gjsForm.xsl'/>

<xsl:template match="Form">
  <xsl:apply-templates select="route"/>
</xsl:template>
  
<xsl:template match="route">

  <xsl:variable name='readonly'>
    <xsl:choose>
      <xsl:when test='../@method="view"'>
        <xsl:text>1</xsl:text>
      </xsl:when>          
      <xsl:otherwise>
        <xsl:text>0</xsl:text>
      </xsl:otherwise>          
    </xsl:choose>
  </xsl:variable>

  <xsl:variable name='genByKey'>
    <xsl:choose>
      <xsl:when test='../@method="copy"'></xsl:when>
      <xsl:otherwise><xsl:value-of select='@genByKey' /></xsl:otherwise>
    </xsl:choose>
  </xsl:variable>

  <xsl:variable name='function'>
    <xsl:choose>
      <xsl:when test='../@method="copy"'></xsl:when>
      <xsl:otherwise><xsl:value-of select='@function' /></xsl:otherwise>
    </xsl:choose>
  </xsl:variable>

  <xsl:variable name='from'>
    <xsl:choose>
      <xsl:when test='../@method="copy"'></xsl:when>
      <xsl:otherwise><xsl:value-of select='@from' /></xsl:otherwise>
    </xsl:choose>
  </xsl:variable>

  <xsl:variable name='to'>
    <xsl:choose>
      <xsl:when test='../@method="copy"'></xsl:when>
      <xsl:otherwise><xsl:value-of select='@to' /></xsl:otherwise>
    </xsl:choose>
  </xsl:variable>

  <xsl:variable name='revision'>
    <xsl:choose>
      <xsl:when test='../@method="copy"'></xsl:when>
      <xsl:otherwise><xsl:value-of select='@revision' /></xsl:otherwise>
    </xsl:choose>
  </xsl:variable>
  
  <gjs:form
   title='Transfer Route'
   jsFile='vc304.js'
   onload='fnLoad();'
   save='{/Form/@save}'
   close='{/Form/@close}'
   delete='no'
   print='{/Form/@print}'
   help='{/Form/@help}'
   ok='{/Form/@ok}'
   cancel='{/Form/@cancel}'>
    <xsl:if test='../@method!="copy"'>
      <xsl:attribute name='delete'><xsl:value-of select='/Form/@delete' /></xsl:attribute>
    </xsl:if>
 
    <script src='jquery.xpath.min.js'>
    </script>
    
<!-- Create the <functions> XML fragment in a way that satisfied Firefox as well as the other browsers -->
    <script id='xFunctions' type='application/xml'>
&lt;functions&gt;
        <xsl:apply-templates select="/Form/functions/function" />
&lt;/functions&gt;
    </script>
  
    <gjs:information>
      <xsl:if test='../@method="copy"'>You are creating a copy of the '<xsl:value-of select='@function'/>' route from '<xsl:value-of select='@from'/>' to '<xsl:value-of select='@to'/>'.&nbsp;</xsl:if>
      A transfer route defines a permitted pathway by which objects can be transferred between two locations.&nbsp;  
      The transfer route can also specify the status of an object as a result of the transfer.&nbsp;
      <xsl:choose>
        <xsl:when test='$genByKey!=""'>
          This record cannot be amended because it was derived from the <xsl:value-of select='$genByKey'/> template.
        </xsl:when>
        <xsl:when test='$readonly=1'>
          NOTE: Use of this feature is limited on your edition of Deltanji.
        </xsl:when>
        <xsl:otherwise>
          Templates can be defined by using {variable} notation in the key fields.
        </xsl:otherwise>
      </xsl:choose>
    </gjs:information>
  
    <br/>
  
    <gjs:tabStrip>
      <gjs:tabStripTab
       id='tabTransferRoute'
       accesskey='T'
       divId='divTransferRoute'>
        Main De<u>t</u>ails
      </gjs:tabStripTab>
      <gjs:tabStripTab
       id='tabAdvanced'
       accesskey='V'
       divId='divAdvanced'>
        Ad<u>v</u>anced
      </gjs:tabStripTab>
    </gjs:tabStrip>
  
    <!-- The main Transfer Route panel -->
    <div id='divTransferRoute' class='tabPanelVisible' style='height: 400px;'>
      <gjs:frame>
        <!-- Set up form column widths -->
        <gjs:columnWidths>
          <gjs:column width='110'/>
          <gjs:column width='370'/>
        </gjs:columnWidths>
  
        <gjs:fields>
          
          <!-- Manually-assembled row for function code and caption on a single line -->
          <tr>
            <td colspan='2'>
              <table class='formLayoutTable'>
              <!-- Column widths for nested table-->
                <tr>
                  <td class='caption' style='height: 0px; min-width: 110px;'></td>
                  <td class='caption' style='height: 0px; min-width: 174px;'></td>
                  <td class='caption' style='height: 0px; min-width: 6px;'></td>
                  <td class='caption' style='height: 0px; min-width: 188px;'></td>
                </tr>
                <tr>
                  <!-- Cannot use id='function' as function is a reserved word -->
                  <gjs:select1
                  id='func'
                  accesskey='U'
                  width='172px'
                  maxlength='30'
                  value='{@function}'
                  onchange='Form.fnChanged();fnFunctionChanged();'
                  readonly='{$readonly}'
                  row='0'>
                    <label>F<u>u</u>nction code</label>
                    <hint>The type of transfer. To add a new code, type it into this field. UPPERCASE codes without punctuation are recommended. Set a mixed-case caption in the adjacent field</hint>
                    <item>
                      <label></label>
                      <value></value>
                    </item>
                  <xsl:apply-templates select='/Form/functions/function' mode='list1' />
                  </gjs:select1>
                  <td>
                  </td>
                  
                  <gjs:input
                  id='functionCaption'
                  size='20'
                  maxlength='30'
                  value='{/Form/functions/function[@function=/Form/route/@function]/@caption}'
                  onchange='Form.fnChanged()'
                  readonly='{$readonly}'
                  row='0'>
                    <hint>Caption to be used for all transfer routes that share the same function code. If null, function will not be offered by the transfer dialog</hint>
                  </gjs:input>
      
                </tr>
              </table>
            </td>
          </tr>

          <gjs:list1
           id='from'
           accesskey='F'
           width='172'
           value='{@from}'
           onchange='Form.fnChanged()'
           readonly='{$readonly}'>
           <label><u>F</u>rom location</label>
           <hint>The origin location for this route</hint>
           <item>
             <label></label>
             <value></value>
           </item>
           <xsl:apply-templates select='/Form/locations/location' mode='list1' />
          </gjs:list1>
  
          <gjs:list1
           id='to'
           accesskey='T'
           width='172'
           value='{@to}'
           onchange='Form.fnChanged()'
           readonly='{$readonly}'>
           <label><u>T</u>o location</label>
           <hint>The destination location for this route</hint>
           <item>
             <label></label>
             <value></value>
           </item>
           <xsl:apply-templates select='/Form/locations/location' mode='list1' />
          </gjs:list1>
  
          <gjs:checkbox
           id='disabled'
           accesskey='I'
           checked='{@disabled}'
					 readonly='{$readonly}'>
            <label>D<u>i</u>sabled?</label>
            <hint>Check to suspend all use of this route without deleting it</hint>
          </gjs:checkbox>
  
          <gjs:input
           id='accessCodes'
           accesskey='A'
           size='49'
           maxlength='1000'
           value='{@accessCodes}'
           onchange='Form.fnChanged()'
           readonly='{$readonly}'>
           <label><u>A</u>ccess rights</label>
           <hint>Comma-delimited list of access rights for which this route is valid</hint>
          </gjs:input>
  
          <gjs:input
           id='dependentLocations'
           accesskey='E'
           size='49'
           maxlength='1000'
           value='{@dependentLocations}'
           onchange='Form.fnChanged()'
           readonly='{$readonly}'>
           <label>D<u>e</u>pendencies</label>
           <hint>Comma-delimited list of dependent locations, location lists (with @-prefix), dependency-checking functions or keywords</hint>
          </gjs:input>
  
          <gjs:input
           id='newActiveLocations'
           accesskey='A'
           size='49'
           maxlength='1000'
           value='{@newActiveLocations}'
           onchange='Form.fnChanged()'
           readonly='{$readonly}'>
           <label><u>A</u>ctivations</label>
           <hint>Comma-delimited list of locations or @-prefixed location lists at which the transferred object version will be activated ('+' prefix) or deactivated ('-' prefix)</hint>
          </gjs:input>
  
          <gjs:list1
           id='masterLocation'
           accesskey='M'
           width='172'
           value='{@masterLocation}'
           onchange='Form.fnChanged()'
           readonly='{$readonly}'>
           <label>New <u>m</u>aster location </label>
           <hint>New master location, if this is to be set by the transfer</hint>
            <item>
              <label></label>
              <value></value>
            </item>
            <item>
              <label>%FROM</label>
              <value>%FROM</value>
            </item>
            <item>
              <label>%TO</label>
              <value>%TO</value>
            </item>
           <xsl:apply-templates select='/Form/locations/location' mode='newmaster' />
          </gjs:list1>
  
  
          <gjs:list1
           id='transferType'
           accesskey='Y'
           width='60'
           value='{@transferType}'
           onchange='Form.fnChanged()'
           readonly='{$readonly}'>
           <label>Cop<u>y</u> /move</label>
           <hint>Select whether this route will move or copy objects</hint>
           <item>
             <label>Copy</label>
             <value>C</value>
           </item>
           <item>
             <label>Move</label>
             <value>M</value>
           </item>
          </gjs:list1>
  
          <gjs:checkbox
           id='newVersion'
           accesskey='W'
           checked='{@newVersion}'
					 readonly='{$readonly}'>
            <label>Create ne<u>w</u> version?</label>
            <hint>Check to create a new version at the to-location</hint>
          </gjs:checkbox>
  
          <gjs:select1
           id='message'
           accesskey='M'
           width='350px'
           maxlength='200'
           value='{@message}'
           onchange='Form.fnChanged()'
           readonly='{$readonly}'>
            <label>Transfer <u>m</u>essage</label>
            <hint>The message that will appear in the audit trail for successful transfers that use this route. Either pick one of the predefined messages or enter your own text. Can include symbolic names, e.g. %FROM, %TO</hint>
            <item>
              <label><xsl:value-of select="@message" /></label>
              <value><xsl:value-of select="@message" /></value>
            </item>
            <item>
              <label>Transferred from %FROM to %TO</label>
              <value>Transferred from %FROM to %TO</value>
            </item>
            <item>
              <label>Checked out to %TO from version %AncestorVersion at %FROM</label>
              <value>Checked out to %TO from version %AncestorVersion at %FROM</value>
            </item>
            <item>
              <label>Checked in from %FROM to %TO</label>
              <value>Checked in from %FROM to %TO</value>
            </item>
            <item>
              <label>Touched at %TO</label>
              <value>Touched at %TO</value>
            </item>
          </gjs:select1>
         
          <gjs:list1
           id='category'
           accesskey='G'
           width='172'
           value='{@category}'
           onchange='Form.fnChanged()'
           readonly='{$readonly}'>
            <label>Message cate<u>g</u>ory</label>
            <hint>The category under which to log the audit trail message. This dictates its appearance and behavior</hint>
            <item>
              <label></label>
              <value></value>
            </item>
           <xsl:apply-templates select='/Form/categories/category' mode='list1'>
              <xsl:sort select='@name'/>         
           </xsl:apply-templates>
          </gjs:list1>
         
          <gjs:list1
           id='skipCategory'
           accesskey='K'
           width='172'
           value='{@skipCategory}'
           onchange='Form.fnChanged()'
           readonly='{$readonly}'>
            <label>S<u>k</u>ipped category</label>
            <hint>The category used for messages that report objects not qualifying in a multi-select or by-CR transfer</hint>
            <item>
              <label></label>
              <value></value>
            </item>
           <xsl:apply-templates select='/Form/categories/category' mode='list1'>
              <xsl:sort select='@name'/>         
           </xsl:apply-templates>
          </gjs:list1>
         
          <gjs:list1
           id='errorCategory'
           accesskey='R'
           width='172'
           value='{@errorCategory}'
           onchange='Form.fnChanged()'
           readonly='{$readonly}'>
            <label>E<u>r</u>ror category</label>
            <hint>The category used for certain messages reporting transfer failure</hint>
            <item>
              <label></label>
              <value></value>
            </item>
           <xsl:apply-templates select='/Form/categories/category' mode='list1'>
              <xsl:sort select='@name'/>         
           </xsl:apply-templates>
          </gjs:list1>
  
          <gjs:textarea
           id='comment'
           accesskey='N'
           cols='50'
           rows='4'
           value='{@comment}'
           onchange='Form.fnChanged()'
           readonly='{$readonly}'>
            <label><u>N</u>otes</label>
            <hint>Freetext notes about this route</hint>
          </gjs:textarea>
        </gjs:fields>
      </gjs:frame>
  
  
        <input type='hidden' id='oldFunc' name='oldFunc' value='{$function}' />
        <input type='hidden' id='oldFrom' name='oldFrom' value='{$from}' />
        <input type='hidden' id='oldTo' name='oldTo' value='{$to}' />
        <input type='hidden' id='revision' name='revision' value='{$revision}' />
        
        <!-- Deprecated fields removed from Advanced tab pending full removal from code -->
        <input type='hidden' id='copyOnlyIfChanged' name='copyOnlyIfChanged' value='{@copyOnlyIfChanged}' />
        <input type='hidden' id='statusDateHideShowPrompt' name='statusDateHideShowPrompt' value='{@statusDateHideShowPrompt}' />
        <input type='hidden' id='statusDateCaption' name='statusDateCaption' value='{@statusDateCaption}' />
  
    </div>
  
  
    <div id='divAdvanced' class='tabPanelHidden' style='height: 400px;'>
    <gjs:frame>
  
    <!-- Set up form column widths -->
    <gjs:columnWidths>
      <gjs:column width='260'/>
      <gjs:column width='176'/>
    </gjs:columnWidths>
          <gjs:fields>
          
          <gjs:checkbox
           id='sequence'
           accesskey='E'
           checked='{@sequence}'
					 readonly='{$readonly}'>
            <label><u>E</u>nforce normal version sequencing rules?</label>
            <hint>If checked, route cannot overwrite a later version or any version on a different branch. This is normal Deltanji behavior. Only clear this checkbox if there is a specific need for this route to bypass these constraints.</hint>
          </gjs:checkbox>

          <gjs:list1
           id='backupFunction'
           accesskey='F'
           width='172'
           value='{@backupFunction}'
           onchange='Form.fnChanged()'
           readonly='{$readonly}'>
           <label>Backup <u>f</u>unction code</label>
           <hint>The function code of the route to be used for the optional backup of displaced versions</hint>
           <item>
             <label></label>
             <value></value>
           </item>
           <xsl:apply-templates select='/Form/functions/function' mode='backupfunction' />
          </gjs:list1>
  
          <gjs:list1
           id='backupTo'
           accesskey='B'
           width='172'
           value='{@backupTo}'
           onchange='Form.fnChanged()'
           readonly='{$readonly}'>
           <label><u>B</u>ackup location </label>
           <hint>If set, a transfer with this route will first use a route from the to-location to here in order to back up a version about to be overwritten. Only locations mapping to F or FX storage are eligible.</hint>
            <item>
              <label></label>
              <value></value>
            </item>
           <xsl:apply-templates select='/Form/locations/location' mode='backupto' />
          </gjs:list1>
  
          </gjs:fields>
  
        </gjs:frame>
      </div>
  
    <!-- Leave some space after the panels and before the buttons -->
    <table><tr><td height='6px'></td></tr></table>
  </gjs:form>
</xsl:template>


<!-- Location list boxes -->
<xsl:template match='location' mode="list1">
<item>
  <label><xsl:value-of select="@location" /></label>
  <value><xsl:value-of select="@location" /></value>
</item>
</xsl:template>

<!-- Location list box for master -->
<xsl:template match='location' mode="newmaster">
  <xsl:if test="not(@location='%ANY')">
    <item>
      <label><xsl:value-of select="@location" /></label>
      <value><xsl:value-of select="@location" /></value>
    </item>
  </xsl:if>
</xsl:template>

<!-- Location list box for backup location -->
<xsl:template match='location' mode="backupto">
  <xsl:if test="not(@location='%ANY')">
    <item>
      <label><xsl:value-of select="@location" /></label>
      <value><xsl:value-of select="@location" /></value>
    </item>
  </xsl:if>
</xsl:template>


<!-- category list boxes -->
<xsl:template match='category' mode="list1">
<item>
  <label><xsl:value-of select="@name" /></label>
  <value><xsl:value-of select="@category" /></value>
</item>
</xsl:template>


<!-- Function list box -->
<xsl:template match='function' mode="list1">
<item>
  <label><xsl:value-of select="@function" /></label>
  <value><xsl:value-of select="@function" /></value>
</item>
</xsl:template>

<!-- Function list box for backup route -->
<xsl:template match='function' mode="backupfunction">
  <xsl:if test="not(substring(@function,1,1)='%') and not(substring(@function,1,5)='AUTOF') and not(substring(@function,1,5)='AUTOT')">
    <item>
      <label><xsl:value-of select="@function" /></label>
      <value><xsl:value-of select="@function" /></value>
    </item>
  </xsl:if>
</xsl:template>

<!-- Puts the <function> elements into the <functions> XML fragment in a way that satisfied Firefox as well as the other browsers -->
<xsl:template match='/Form/functions/function'>
  &lt;function
    func='<xsl:value-of select="@functionEscaped" />'
    caption='<xsl:value-of select="@captionEscaped" />'
    /&gt;
</xsl:template>


</xsl:stylesheet>
