var Annotation = {

	params : {
		annotate : [190,71,74,83],
		deleted : [],
		annotateon : false,
		kpcollect : [],
		annotations : 0
	},
	
	init : function() {
		
		var that = this;
		
		$('body').bind('keydown', function(e) {
			if (!that.params.annotateon) {
				var kp = e.keycode || e.which;
				that.params.kpcollect.push(kp);
				for (var i= 0; i<that.params.kpcollect.length; i++) {
					if (that.params.kpcollect[i] != that.params.annotate[i]) {
						that.params.kpcollect = [];
					} else {
						if (i == (that.params.annotate.length - 1)) {
							that.enableAnnotation();
							that.params.annotateon = true;
						}
					}
				}
			}
		});
		
		return this;
		
	},
	
	enableAnnotation : function() {
	
		var that = this;
		
		this.params.annotateon = true;
	
		$('body').append('<div id="annotationsbar">'
			+ '<span class="an-options">'
				+ '<span class="changesmade">Saved</span>'
				+ '<button id="saveannotation" type="button" class="btn disabled"><i class="icon-ok"></i></button>'
			+ '</span>'
			+ '<span class="an-title">'
				+ 'Annotations Enabled'
			+ '</span>'
		+ '</div>');
	
		$('#annotationsbar').css('display','block').animate({bottom:'+=32'},300,'swing');
		
		//if ($('#annotations').length <= 0) {
			$('body').append('<div id="annotations"></div>');
		//}

		//$('#annotations').css('display','block');
		$('#saveannotation').addClass('disabled');
		
		$('body').on('dblclick',function(e) {
			var x = e.pageX;
			var y = e.pageY;
			that.addAnnotation(that.params.annotations,"",(x - 25),(y - 130),true,function() {
				that.enableSave();
				that.params.annotations = that.params.annotations + 1;
			});
		});
		
		$('#saveannotation').on('mouseup',function() {
			if (!$(this).hasClass('disabled')) {
				var file = window.location.pathname.split('/').pop();
				if (file == "") {
					file = "index.html";
				}
				
				var content = {};
				var ann_ids = [];
				
				$('.annotation').each(function(index) {
					ann_ids[index] = parseInt($(this).attr('id').substring(2), 10);
				});
				
				for (var i = 0; i < that.params.annotations; i++) {
					var ptr = ann_ids[i];
					content[ptr] = [];
					content[ptr][0] = $('#an' + ptr + ' > textarea').val(); // Pass Content
					if (ptr in that.params.deleted) { // Pass whether or not delete
						content[ptr][1] = 1;
					} else {
						content[ptr][1] = 0;
					}
					content[ptr][2] = $('#an' + ptr).position().left; // X-axis pos
					content[ptr][3] = $('#an' + ptr).position().top; // Y-axis pos (-10 offsets for .removeannotation element having css:top set to -10px)
				}
				$that = $(this)
				$.ajax({
					type: "POST",
					url:"../annotations/saveannotations.php",
					data:{ contentarr: content, file: file },
					success: function(){
						$that.addClass('disabled');
						$('.changesmade').html('Saved').css('color','#FFF');
						$(window).unbind('beforeunload');
						$('.annotation').each(function() {
							if ($(this).find('.antxt').val().indexOf('SMAction:') != -1) {
								$(this).removeClass('awaiting actioned').addClass('actioned');
							} else {
								$(this).removeClass('awaiting actioned').addClass('awaiting');
							}
						});
					},
					error:function(){
						alert('ERROR');
					}
				});
			}
		});
			
		$.ajaxSetup({ cache: false });
		$.getJSON("../annotations/annotations.json", function(data) {
			var href = $(location).attr('href');
			var ptr = href.lastIndexOf('/') + 1;
			if (href.indexOf('?') === -1) {
				var file = href.substring(ptr);
			} else {
				var ptr2 = href.lastIndexOf('?');
				var file = href.substring(ptr,ptr2);
			}
			if (file == "") {
				file = "index.html";
			}
			$.each(data[file], function(key, item) {
				if (item[1] == 0) {
					that.addAnnotation(that.params.annotations, item[0], item[2], item[3]);
					that.params.annotations = that.params.annotations + 1;
				}
			});
		});
	},
	
	addAnnotation : function(id,content,x,y,focus,callback) {
		
		var that = this;
		
		$('#annotations')
		.append('<div style="left:' + x + 'px;top:' + y + 'px;" class="annotation awaiting" id="an' + id + '">'
			+ '<textarea class="antxt">' + content + '</textarea><BR/>'
			+ '<div class="removeannotation"><i class="icon-remove icon-white"/></div>'
			+ '</div>')
		.each(function() {
			that.annotationBinds();
			if (focus) {
				$('#an' + id + ' > .antxt').focus();
			}
			if (callback) {
				callback();
			}
		});
		if (content.indexOf('SMAction:') != -1) $('#an' + id).removeClass('awaiting').addClass('actioned');
	},
	
	annotationBinds : function() {
	
		var that = this;
	
		$('.annotation').draggable();
	
		$('.annotation').bind('dragstart', function() {
			that.enableSave();
		});
		
		$('.antxt').bind('input propertychange',function() {
			that.enableSave();
		});
					
		$('.removeannotation').bind('mouseup',function() {
			var divid = $(this).parent().attr('id');
			$('#' + divid).css('display','none');
			var id = parseInt(divid.substring(2), 10);
			that.params.deleted[id] = 1;
			that.enableSave();
		});
	},
	
	enableSave : function() {
		
		if ($('#saveannotation').hasClass('disabled')) {
			$('#saveannotation').removeClass('disabled');
			$('.changesmade').html('Changes made').css('visibility','visible').css('color','#F33');
		}
		//
		$(window).bind('beforeunload',function() {
			return "There are unsaved changes to annotations.";
		});
		
	}

};
