<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet 
 version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:exslt="http://exslt.org/common"
 xmlns:msxsl="urn:schemas-microsoft-com:xslt"
 xmlns:gjs="http://www.georgejames.com"
 exclude-result-prefixes="exslt msxsl">

<!-- Standard form controls  
     ======================
     Loosely based on the xforms 1.0 specification but
     without the notion of binding to a model or event processing etc.
-->


<!-- Apply templates that are in the main body of the document and capture the output
     in the string variable sDocument.  This executes the normal xsl processing of the
     main document. -->
<xsl:variable name="sDocument">
  <xsl:apply-templates/>
</xsl:variable>


<!-- Convert the sDocument variable from a string to a node-set and process the node-set.
     Use mode="controls" to make this processing
     distinct from that of the main document. -->

<xsl:template match="/">
  <xsl:choose>
    <xsl:when test="function-available('exslt:node-set')">
      <xsl:apply-templates select="exslt:node-set($sDocument)" mode="controls" />
    </xsl:when>
    <xsl:when test="function-available('msxsl:node-set')">
      <xsl:apply-templates select="msxsl:node-set($sDocument)" mode="controls" />
    </xsl:when>
  </xsl:choose>
</xsl:template>

<!-- Copy Verbatim
     =============
     The following template copies everthing verbatim, but applies any relevant templates along the
     way.  This way, elements like <allSystems/> can be used wherever you need them.
     Note this is done for both normal mode and for controls mode.
-->
<xsl:template match="@*|*">
  <xsl:copy>
  <xsl:apply-templates select="@*|node()" />
  </xsl:copy>
</xsl:template>

<xsl:template match="@*|*" mode="controls">
  <xsl:copy>
  <xsl:apply-templates select="@*|node()" mode="controls"/>
  </xsl:copy>
</xsl:template>



<!-- ===================================== -->

<xsl:include href='gjsControlsTemplates.xsl'/>

<!-- ===================================== -->



</xsl:stylesheet>
