//vc/ gjs - Generic Form Manager
//vc/ Copyright 2003 George James
//vc/ Object:    gjsForm.js


// Tab-strip class
TabStrip = {}

TabStrip.selectedFrame=null;
TabStrip.selectedTab=null;

TabStrip.fnSelect = function(oTab) {
	if (TabStrip.selectedTab) {
		TabStrip.selectedTab.tabIndex=-1;
		$(TabStrip.selectedTab).removeClass().addClass('tabStripTab');
		$(TabStrip.selectedFrame).removeClass().addClass('tabPanelHidden');
	}
	//
	TabStrip.selectedTab=oTab;
	TabStrip.selectedTab.tabIndex=0;
	TabStrip.selectedFrame=document.getElementById(getAttr(oTab,"gjsDivId"));
	$(TabStrip.selectedFrame).removeClass().addClass('tabPanelVisible');
	$(TabStrip.selectedTab).removeClass().addClass('tabStripTabSelected');
}


TabStrip.fnKeyDown = function(oTab,event) {
	var oAdjacentTab;
	if ((event.keyCode==37) && !event.altKey) { //Left-arrow
		oAdjacentTab=oTab.previousElementSibling;
		if (oAdjacentTab!=null) {
			oAdjacentTab.focus();
		}
		Form.fnEventStop(event);
	}
	if ((event.keyCode==39) && !event.altKey) { //Right-arrow
		oAdjacentTab=oTab.nextElementSibling;
		if ((oAdjacentTab!=null) && !($(oAdjacentTab).hasClass('tabStripTabNone'))) {
			oAdjacentTab.focus();
		}
		Form.fnEventStop(event);
	}
}


// Form class
Form = {}

Form.bChanged=false
Form.winHelp=null
Form.winHelpProperties=null
if (parent.opener) Form.winHelpProperties=parent.opener.winHelpProperties
Form.oSelectedRow=null

Form.fnHelp = function(event) {
	if (typeof(fnHelp)=='function') {
		fnHelp()	
	} else {
		winHelp=window.open('WebDoc/docs/index.html','vcmHelp',Form.winHelpProperties) ;
		winHelp.focus();
	}	
	Form.fnEventStop(event);
}


Form.fnChanged = function() {
	Form.bChanged=true;
	status="Modified";
}


Form.fnClose = function(event) {
	if (Form.bChanged) {
		alert("There are unsaved changes.  After dismissing this message, click the Cancel button again if you really want to close the window without saving.")
		Form.bChanged=false
		if (event) {
			Form.fnEventStop(event);
		}
		return
	}
	parent.fnClose()
}


Form.fnDelete = function() {
	//
	if (!confirm("Are you sure you want to delete this record?")) return;
	//
	// Invoke application specific delete method
	fnItemDelete();
}
	

	// Invoked when changes have been saved
Form.fnSaved = function(thisClass) {
	//
	Form.bChanged=false
	status="Saved"
	Form.fnRefresh(thisClass)
}


Form.fnRefresh = function(thisClass,bFullReload) {
  var bRefreshed=false;
  var oEl
  
  if (typeof(bFullReload)=='undefined') bFullReload=false
  
	if (!parent.opener) return; // In case main window has been closed
	if (parent.opener.SelectedClass!=thisClass) return; // In case main window has changed to some other screen
	
	// If full reload requested, locate +/- cell of selected item and run its reload
	if (bFullReload) {
    if (typeof(parent.opener.SelectedClass.selectedCells)!="undefined") {
      if (parent.opener.SelectedClass.selectedCells.length>0) {
        oEl=parent.opener.fnElement(parent.opener.SelectedClass.selectedCells[0])
        oEl=oEl.parentNode.parentNode.parentNode.parentNode.parentNode
        if (oEl.tagName=='TBODY') {
          parent.opener.fnToggleExpand(parent.opener.fnElement(getAttr(oEl,"gjsClickId")))
          bRefreshed=true
        }
      }
    }
  }
  
  if (bRefreshed) return;
  //
  // If fnRefresh method is available and acceptable then use it
  if ((parent.opener.SelectedClass.fnRefresh)&&(!bFullReload)) bRefreshed=parent.opener.fnRefreshSelected();
  if (bRefreshed) return;
  //
  // If we couldn't do a selective refresh, try a full one
  if (parent.opener.SelectedClass.fnList)	parent.opener.SelectedClass.fnList(); 
}


	// ------------------------- Row selection and manipulation ---------------



	// Row Change Manager
	// The *second* row forms the template for new rows, it should be blank and hidden
	// The last row should be blank but not hidden.  When a value is entered in the
	// last row, then a new row should be added using the *second* row as a template.
	// [The first row is used to set the column widths and is normally empty].
Form.fnRowChanged = function(oThisRow) {
	//
	//if (typeof(console)!='undefined') console.log('Starting fnRowChanged');
	var oTableBody,oNewRow,oFirstRow,oNewCell,i;
	//
	Form.fnChanged();
	//
	// Is this the last row?
	if (getAttr(oThisRow,"gjsLastRow")=='0') return;
	setAttr(oThisRow,"gjsLastRow","0");
	//
	// Clone *second* row (including its events) as new last row
	oTableBody=$(oThisRow).parent();
	oNewRow = $(oTableBody).children("tr:nth-of-type(2)");
	//if (typeof(console)!='undefined') console.log(oNewRow);
	$(oNewRow).clone(true).attr("gjsLastRow","1").css("display","table-row").appendTo(oTableBody);
	//
	// Make new row visible and add to table
	// $(oNewRow).css("display","block");
	//if (typeof(console)!='undefined') console.log('Ending fnRowChanged');
}


	// Toggle row selection
Form.fnRowSelect = function(oRow,event) {
	//
	// Deselect current row
	if (Form.oSelectedRow==oRow) {
		$(Form.oSelectedRow).removeClass().addClass('row');
		Form.oSelectedRow=null;
	}
	else { 
		if (Form.oSelectedRow) $(Form.oSelectedRow).removeClass().addClass('row');
		Form.oSelectedRow=oRow;
		$(Form.oSelectedRow).removeClass().addClass('selectedRow');
	}
	//
	event.cancelBubble=true;
}


	// Move selected row up one
Form.fnRowUp = function() {
	//
	var oBody,oPreviousRow
	//
	if (!Form.oSelectedRow) return;
	//
	if (Form.oSelectedRow.rowIndex<2) return;
	//
	oBody=Form.oSelectedRow.parentNode;
	oPreviousRow=Form.oSelectedRow.previousElementSibling;	
	oBody.insertBefore(Form.oSelectedRow,oPreviousRow);
  //
  Form.fnChanged()
}


	// Move selected row down one
Form.fnRowDown = function() {
	//
	var oBody,oNextRow
	//
	if (!Form.oSelectedRow) return;
	//
	if (!Form.oSelectedRow.nextElementSibling) return;
	//
	oBody=Form.oSelectedRow.parentNode;
	oNextRow=Form.oSelectedRow.nextElementSibling;	
	oBody.insertBefore(oNextRow,Form.oSelectedRow);
  //
  Form.fnChanged()
}


	// Reset row selection
Form.fnRowReset = function() {
	if (Form.oSelectedRow) {
		$(Form.oSelectedRow).removeClass().addClass('row');
		Form.oSelectedRow=null;
	}
}


	// ------------------------- Autosize functions ------------

Form.fnAutoSize = function() {
	// Resize window to lower right corner of element with ID oFormAutoSizer.
	// Intended to be called from body onload.
	// IE security 'fix' gives 'Access is denied' if called when mouse is down (bizarre!), so don't
	// call from mouse-related events.
	//
	var oElement;
	var iWidth;
	var iHeight;

	// Look for element with magic ID
	oElement = document.getElementById("oFormAutoSizer");
	//if (typeof(console)!='undefined') console.log(oElement);
	if (oElement==null) return;
	
	// No autosizing if not using relative positioning (e.g. CW form in main frame)
	if (!oElement.offsetParent) return;
	
	// Work out its lower right window coords
	iWidth=Form.fnAutoSizeFindLeftOffset(oElement)+$(oElement).outerWidth();
	iHeight=Form.fnAutoSizeFindTopOffset(oElement)+$(oElement).outerHeight();

	// Add the body's margin
	var m_r = parseInt($('body').css('margin-right'));
	var m_b = parseInt($('body').css('margin-bottom'));
	m_r = (isNaN(m_r)) ? 0 : m_r;
	m_b = (isNaN(m_b)) ? 0 : m_b;
	iWidth=iWidth + m_r;
	iHeight=iHeight + m_b;

	// Respect a minimum size
	iWidth=(iWidth<100)?100:iWidth;
	iHeight=(iHeight<100)?100:iHeight;

	// Resize so client region is correct. Operates on top so it's correct for frameset pre-XP
	// and so it works when we are hosted in an iframe (e.g. Ensemble 2012.1+ Portal's source control dialog mechanism).
	// IE security 'fix' gives 'Access is denied' if called when mouse is down (bizarre!) - we ignore the error
	try {
		top.resizeBy(iWidth-$(top.document.body).width(),iHeight-$(top.document.body).height());
	}
	catch(e) {}
}

	// Private helper for above
Form.fnAutoSizeFindLeftOffset = function(elem) {
	var left = 0;
	while (elem.tagName != "BODY") {
		left += $(elem).offset().left;
		elem = elem.offsetParent;
	}
	return left;
}

	// Private helper for above
Form.fnAutoSizeFindTopOffset = function(elem) {
	var top = 0;
	while (elem.tagName != "BODY") {
		top += $(elem).offset().top;
		elem = elem.offsetParent;
	}
	return top;
}


	// ------------------------- Event handlers ---------------

Form.fnKeyDown = function(event) {
	//
	// Selected row keyboard events
	if (Form.oSelectedRow) {
		if (event.keyCode==38) {
    	var elem=event.srcElement || event.target;
			Form.fnRowUp();
      
			// At least on IE, if we don't refocus to the element we can't use the keyboard to move a row up more than one place
			elem.focus();
      
			Form.fnEventStop(event);
		}
		if (event.keyCode==40) {
			Form.fnRowDown();
			Form.fnEventStop(event);
		}
	}
	//
	// Escape key and the form is of type ok/cancel
	// Move focus there to ensure any onchange fires for currently-focused field, then simulate a click on the Cancel
	if (event.keyCode==27) {
		var elCancel=document.getElementById("cmdCancel")
		if (elCancel){ elCancel.focus(); elCancel.click(); Form.fnEventStop(event)}
	}
  //
  // The user may accidentally try to use some keyboard shortcuts
  // Ctrl+N
	if ((event.keyCode==78)&&(event.ctrlKey)) Form.fnEventStop(event)
	// ctrl O for File/New
	if ((event.keyCode==79)&&(event.ctrlKey)) Form.fnEventStop(event)
	//
	// Capture some IE function keys
	if (event.keyCode==114) { Utility.fnDebug(); return Form.fnEventStop(event); } // F3 - Search
}


  // Bulletproof method for stopping events from bubbling
Form.fnEventStop = function(event) {
	event.keyCode=0; // Required to stop F5 key
	event.returnValue=false;
	event.cancelBubble=true;
	if (event.preventDefault) event.preventDefault();
	if (event.stopPropagation) event.stopPropagation();
	return false;
}


Form.fnBeforeUnload = function(event) {
	if (Form.bChanged) event.returnValue="There are unsaved changes.";
}


Form.fnUnload = function() {
	// Close child windows
	if (Form.winHelp) Form.winHelp.close();
}


	// Utility Class
	// ***!!! A Utility object is defined in vc700.js and overrides this one:
Utility = {}

	// Public - Toggle Debug window
	// If the debug window is closed, open it.
	// Otherwise, close it.
Utility.fnDebug = function() {
	if (parent.framesetMain.cols=='0,1*') parent.framesetMain.cols='150,1*';
	else parent.framesetMain.cols='0,1*';
}


// onbeforeunload doesn't work in an xml page see kb article 328807
// http://support.microsoft.com/default.aspx?scid=kb;en-us;328807&Product=ie
//window.onbeforeunload=Form.fnBeforeUnload;

window.onunload=Form.fnUnload;
window.onkeydown=Form.fnKeyDown;
window.onhelp=Form.fnHelp;
